#include "dspmonitor.h"
#include "ui_dspmonitor.h"
#include <cmath>

DspMonitor::DspMonitor(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::DspMonitor)
{
  ui->setupUi(this);
  ui->labelbez_1->setText("RX input");
  ui->labelbez_2->setText("Noise blank");
  ui->labelbez_3->setText("After Filter");
  ui->labelbez_4->setText("After AGC");
  ui->labelbez_5->setText("Auto notch output");
  ui->labelbez_6->setText("Denoiser uotput");
  ui->labelbez_7->setText("Before AF gain");
  ui->labelbez_8->setText("Rx AF out");
  ui->label_12->setText("S-Meter");
  on_Buttonreset_clicked();
}

DspMonitor::~DspMonitor()
{
  delete ui;
}

void DspMonitor::getdspdaten(const TDspDaten &dspdaten){
  TDspDaten dspd;
  QString qs;
  int db;

  dspd = dspdaten;
  if(TXon != dspd.TXon){
    TXon = dspd.TXon;
    if(TXon){
      ui->labelbez_1->setText("RX input");
      ui->labelbez_2->setText("Noise blank");
      ui->labelbez_3->setText("After Filter");
      ui->labelbez_4->setText("After AGC");
      ui->labelbez_5->setText("Auto notch output");
      ui->labelbez_6->setText("Denoiser uotput");
      ui->labelbez_7->setText("Before AF gain");
      ui->labelbez_8->setText("Rx AF out");
      ui->label_12->setText("S-Meter");
      ui->label_9->setText("AD603 dac");
      ui->label_13->show();
      ui->label_15->show();
      ui->label_adc->show();
      ui->label_agc->show();
      ui->label_ad603->show();
      ui->label_10->show();
      ui->label_totalgain->show();
      ui->label_totalgain2->show();
      ui->progresstotalgain->show();
    }else{
      ui->labelbez_1->setText("Mic input");
      ui->labelbez_2->setText("After decimation");
      ui->labelbez_3->setText("After noise gate");
      ui->labelbez_4->setText("After filter");
      ui->labelbez_5->setText("After VOGAD");
      ui->labelbez_6->setText("After Compression");
      ui->labelbez_7->setText("Tx monitor out");
      ui->labelbez_8->setText("Tx IF out");
      ui->label_12->setText("Tx out");
      ui->label_9->setText("VOGAD");
      ui->label_13->hide();
      ui->label_15->hide();
      ui->label_adc->hide();
      ui->label_agc->hide();
      ui->label_ad603->hide();
      ui->label_10->hide();
      ui->label_totalgain->hide();
      ui->label_totalgain2->hide();
      ui->progresstotalgain->hide();
    }
  }
  //RX input
  qs.sprintf("%04X",dspd.adc);
  ui->label_1->setText(qs);
  db = dspdat2db(dspd.adc);
  ui->progressBar_1->setValue(db);
  if(db>adcmax)adcmax=db;
  qs.sprintf("%i",adcmax);
  ui->labelmax_1->setText(qs);
  if(db<adcmin)adcmin=db;
  qs.sprintf("%i",adcmin);
  ui->labelmin_1->setText(qs);
  qs.sprintf("%i",adcmax-adcmin);
  ui->labeldiff_1->setText(qs);
  //Noise blank
  qs.sprintf("%04X",dspd.devbyte6);
  ui->label_2->setText(qs);
  db = dspdat2db(dspd.devbyte6);
  ui->progressBar_2->setValue(db);
  if(db>devbyte6max)devbyte6max=db;
  qs.sprintf("%i",devbyte6max);
  ui->labelmax_2->setText(qs);
  if(db<devbyte6min)devbyte6min=db;
  qs.sprintf("%i",devbyte6min);
  ui->labelmin_2->setText(qs);
  qs.sprintf("%i",devbyte6max-devbyte6min);
  ui->labeldiff_2->setText(qs);
  //After Filter
  qs.sprintf("%04X",dspd.devbyte1);
  ui->label_3->setText(qs);
  db = dspdat2db(dspd.devbyte1);
  ui->progressBar_3->setValue(db);
  if(db>devbyte1max)devbyte1max=db;
  qs.sprintf("%i",devbyte1max);
  ui->labelmax_3->setText(qs);
  if(db<devbyte1min)devbyte1min=db;
  qs.sprintf("%i",devbyte1min);
  ui->labelmin_3->setText(qs);
  qs.sprintf("%i",devbyte1max-devbyte1min);
  ui->labeldiff_3->setText(qs);
  //After AGC
  qs.sprintf("%04X",dspd.devbyte2);
  ui->label_4->setText(qs);
  db = dspdat2db(dspd.devbyte2);
  ui->progressBar_4->setValue(db);
  if(db>devbyte2max)devbyte2max=db;
  qs.sprintf("%i",devbyte2max);
  ui->labelmax_4->setText(qs);
  if(db<devbyte2min)devbyte2min=db;
  qs.sprintf("%i",devbyte2min);
  ui->labelmin_4->setText(qs);
  qs.sprintf("%i",devbyte2max-devbyte2min);
  ui->labeldiff_4->setText(qs);
  //Auto notch output
  qs.sprintf("%04X",dspd.devbyte4);
  ui->label_5->setText(qs);
  db = dspdat2db(dspd.devbyte4);
  ui->progressBar_5->setValue(db);
  if(db>devbyte4max)devbyte4max=db;
  qs.sprintf("%i",devbyte4max);
  ui->labelmax_5->setText(qs);
  if(db<devbyte4min)devbyte4min=db;
  qs.sprintf("%i",devbyte4min);
  ui->labelmin_5->setText(qs);
  qs.sprintf("%i",devbyte4max-devbyte4min);
  ui->labeldiff_5->setText(qs);
  //Denoiser uotput
  qs.sprintf("%04X",dspd.devbyte5);
  ui->label_6->setText(qs);
  db = dspdat2db(dspd.devbyte5);
  ui->progressBar_6->setValue(db);
  if(db>devbyte5max)devbyte5max=db;
  qs.sprintf("%i",devbyte5max);
  ui->labelmax_6->setText(qs);
  if(db<devbyte5min)devbyte5min=db;
  qs.sprintf("%i",devbyte5min);
  ui->labelmin_6->setText(qs);
  qs.sprintf("%i",devbyte5max-devbyte5min);
  ui->labeldiff_6->setText(qs);
  //Before AF gain
  qs.sprintf("%04X",dspd.devbyte3);
  ui->label_7->setText(qs);
  db = dspdat2db(dspd.devbyte3);
  ui->progressBar_7->setValue(db);
  if(db>devbyte3max)devbyte3max=db;
  qs.sprintf("%i",devbyte3max);
  ui->labelmax_7->setText(qs);
  if(db<devbyte3min)devbyte3min=db;
  qs.sprintf("%i",devbyte3min);
  ui->labelmin_7->setText(qs);
  qs.sprintf("%i",devbyte3max-devbyte3min);
  ui->labeldiff_7->setText(qs);
  //Rx AF out
  qs.sprintf("%04X",dspd.dac);
  ui->label_8->setText(qs);
  db = dspdat2db(dspd.dac);
  ui->progressBar_8->setValue(db);
  if(db>dacmax)dacmax=db;
  qs.sprintf("%i",dacmax);
  ui->labelmax_8->setText(qs);
  if(db<dacmin)dacmin=db;
  qs.sprintf("%i",dacmin);
  ui->labelmin_8->setText(qs);
  qs.sprintf("%i",dacmax-dacmin);
  ui->labeldiff_8->setText(qs);

  qs.sprintf("%i dB",dspd.sigdb);
  ui->label_sigdb->setText(qs);
  if(dspd.TXon){
    if(dspd.sled <= 9){
      qs.sprintf("S%i",dspd.sled);
    }else{
      qs.sprintf("+%idb",(dspd.sled - 9) * 10);
    }
    ui->labelsmeter->setText(qs);
    qs.sprintf("%i",dspd.gain);
    ui->label_gain->setText(qs);
  }else{
    qs.sprintf("%i",dspd.micegain);
    ui->label_gain->setText(qs);
    ui->labelsmeter->setText("");
  }
  ui->progressSmeter->setValue(dspd.sled);
  qs.sprintf("%i",dspd.hff);
  ui->label_ad603->setText(qs);
  qs.sprintf("%i",dspd.adcdb);
  ui->label_adc->setText(qs);
  qs.sprintf("%i",dspd.agcdb);
  ui->label_agc->setText(qs);
  int totalgain = dspd.agcdb + dspd.agcdb + dspd.gain;
  qs.sprintf("%idb",totalgain);
  ui->label_totalgain->setText(qs);
  qs.sprintf("%idb",123 - totalgain);
  ui->label_totalgain2->setText(qs);
  int prtgain = 123 - totalgain;
  if(prtgain < 0)prtgain = 0;
  ui->progresstotalgain->setValue(prtgain);
  if(dspd.TXon){
    if(dspd.spk){
      ui->label_spike->setText("Spike");
    }else{
      ui->label_spike->setText("");
    }
    if(dspd.hang){
      ui->label_hang->setText("Hang");
    }else{
      ui->label_hang->setText("");
    }
  }else{
    ui->label_spike->setText("");
    ui->label_hang->setText("");
  }
}

int DspMonitor::dspdat2db(unsigned int bg){
  double b;
  int dB;

  b = double (bg);
  if(b == 0.0){
    dB = 90;
  }else{
    dB = int(qRound(8.685889638000001 * log(pow(2.0,15.0) / b)));
  }
  dB = 90 - dB;
  return dB;
}


void DspMonitor::on_Buttonreset_clicked()
{
  adcmin=90;
  adcmax=0;
  dacmin=90;
  dacmax=0;
  devbyte1min=90;
  devbyte1max=0;
  devbyte2min=90;
  devbyte2max=0;
  devbyte3min=90;
  devbyte3max=0;
  devbyte4min=90;
  devbyte4max=0;
  devbyte5min=90;
  devbyte5max=0;
  devbyte6min=90;
  devbyte6max=0;
}
