//
// C++ Implementation: optiondlg
//
// Description: 
//
//
// Author: Andreas Lindenau <DL4JAL@darc.de>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <QFileDialog>
#include "optiondlg.h"


//#####################################################################################
// Class fuer Option
//#####################################################################################
odlg::odlg()
{
  
  this->resize(560,720);
  this->setMinimumSize(0,0);
  QString qs;
//  QFont font("Helvetica", pfontsize);

  ok = new QPushButton(tr("OK","Option Dialog"), this);
  ok->setGeometry(10,10,100,30);
  QObject::connect( ok, SIGNAL(clicked()), this, SLOT(accept()));
  cancel = new QPushButton(tr("Abbruch","Option Dialog"), this);
  cancel->setGeometry(10,50,100,30);
  QObject::connect( cancel, SIGNAL(clicked()), this, SLOT(reject()));
  
  tabwidget = new QTabWidget(this);
  tabwidget->setGeometry(120,0,440,710);
  wallgemein = new QWidget();
  tabwidget->addTab(wallgemein, tr("Grunddaten","Option Dialog"));
  //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  grs232 = new QGroupBox(wallgemein);
  grs232->setGeometry(10,60,400,150);
  grs232->setTitle(tr("RS232-Serielle Schnittstelle","Option Dialog"));
  lrs232 = new QLabel(grs232);
  lrs232->setGeometry(10,25,120,30);
  lrs232->setText(tr("Schnittstelle: ","Option Dialog"));
  lrs232->setAlignment(Qt::AlignRight);
  //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  crs232 = new QComboBox(grs232);
  crs232->setGeometry(130,20,140,25);
  crs232->setEditable(TRUE);
#ifdef Q_WS_WIN
  for(int i=1;i<=256;i++){
    qs.sprintf("COM%i",i);
    crs232->addItem(qs);
  }
#else
  crs232->addItem(schnittstelle1);
  crs232->addItem(schnittstelle2);
  crs232->addItem(schnittstelle3);
  crs232->addItem(schnittstelle4);
  crs232->addItem(schnittstelle5);
  crs232->addItem(schnittstelle6);
  crs232->addItem(schnittstelle7);
  crs232->addItem(schnittstelle8);
#endif
  sppicrs232wtime = new QSpinBox(grs232);
  sppicrs232wtime->setGeometry(300,60,60,25);
  sppicrs232wtime->setMinimum(0);
  sppicrs232wtime->setMaximum(100);
  lpicrs232wtime = new QLabel(grs232);
  lpicrs232wtime->setGeometry(10,65,290,30);
  lpicrs232wtime->setText(tr("Daten -> PIC WriteDelay (mSek): ","Option Dialog"));
  lpicrs232wtime->setAlignment(Qt::AlignRight);
  
  spdsprs232wtime = new QSpinBox(grs232);
  spdsprs232wtime->setGeometry(300,90,60,25);
  spdsprs232wtime->setMinimum(0);
  spdsprs232wtime->setMaximum(100);
  ldsprs232wtime = new QLabel(grs232);
  ldsprs232wtime->setGeometry(10,95,290,30);
  ldsprs232wtime->setText(tr("Daten -> DSP WriteDelay (mSek): ","Option Dialog"));
  ldsprs232wtime->setAlignment(Qt::AlignRight);

  spparamrs232wtime = new QSpinBox(grs232);
  spparamrs232wtime->setGeometry(300,120,60,25);
  spparamrs232wtime->setMinimum(0);
  spparamrs232wtime->setMaximum(100);
  lparamrs232wtime = new QLabel(grs232);
  lparamrs232wtime->setGeometry(10,125,290,30);
  lparamrs232wtime->setText(tr("Parameter -> DSP WriteDelay (mSek): ","Option Dialog"));
  lparamrs232wtime->setAlignment(Qt::AlignRight);
  //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  int abstand = 57;
  for(int i=0; i<3; i++){  
    wstar[i] = new QWidget();
    qs.sprintf("PicAStar HW%1i",i+1);
    tabwidget->addTab(wstar[i], qs);
    
    int yp=9;
    
    lstarpfad[i] = new QLabel(wstar[i]);
    lstarpfad[i]->setGeometry(10,yp,320,30);
    lstarpfad[i]->setText(tr("Verzeichnis der Star-Software","Option Dialog"));
    estarpfad[i] = new QLineEdit(wstar[i]);
    estarpfad[i]->setGeometry(10,yp+25,320,30);
    bstarpfad[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    bstarpfad[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( bstarpfad[i], SIGNAL(clicked()), this, SLOT(clickbstarpfad()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ldspcodefilename[i] = new QLabel(wstar[i]);
    ldspcodefilename[i]->setGeometry(10,yp,320,30);
    ldspcodefilename[i]->setText(tr("Datei der DSP-Software","Option Dialog"));
    edspcodefilename[i] = new QLineEdit(wstar[i]);
    edspcodefilename[i]->setGeometry(10,yp+25,320,30);
    bdspcodefilename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    bdspcodefilename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( bdspcodefilename[i], SIGNAL(clicked()), this, SLOT(clickbdspcodefilename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    lfilterfilename[i] = new QLabel(wstar[i]);
    lfilterfilename[i]->setGeometry(10,yp,320,30);
    lfilterfilename[i]->setText(tr("Daten-Dateien der DSP-Software","Option Dialog"));
    efilterfilename[i] = new QLineEdit(wstar[i]);
    efilterfilename[i]->setGeometry(10,yp+25,320,30);
    bfilterfilename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    bfilterfilename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( bfilterfilename[i], SIGNAL(clicked()), this, SLOT(clickbfilterfilename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    lad603filename[i] = new QLabel(wstar[i]);
    lad603filename[i]->setGeometry(10,yp,320,30);
    lad603filename[i]->setText(tr("AD603 DAC-Anpassung DSP-Software","Option Dialog"));
    ead603filename[i] = new QLineEdit(wstar[i]);
    ead603filename[i]->setGeometry(10,yp+25,320,30);
    bad603filename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    bad603filename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( bad603filename[i], SIGNAL(clicked()), this, SLOT(clickbad603filename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    lparameterfilename[i] = new QLabel(wstar[i]);
    lparameterfilename[i]->setGeometry(10,yp,320,30);
    lparameterfilename[i]->setText(tr("User-Parameter der DSP-Software","Option Dialog"));
    eparameterfilename[i] = new QLineEdit(wstar[i]);
    eparameterfilename[i]->setGeometry(10,yp+25,320,30);
    bparameterfilename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    bparameterfilename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( bparameterfilename[i], SIGNAL(clicked()), this, SLOT(clickbparameterfilename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    lxparameterfilename[i] = new QLabel(wstar[i]);
    lxparameterfilename[i]->setGeometry(10,yp,320,30);
    lxparameterfilename[i]->setText(tr("X-Parameter der DSP-Software","Option Dialog"));
    exparameterfilename[i] = new QLineEdit(wstar[i]);
    exparameterfilename[i]->setGeometry(10,yp+25,320,30);
    bxparameterfilename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    bxparameterfilename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( bxparameterfilename[i], SIGNAL(clicked()), this, SLOT(clickbxparameterfilename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    lstandardparameterfilename[i] = new QLabel(wstar[i]);
    lstandardparameterfilename[i]->setGeometry(10,yp,320,30);
    lstandardparameterfilename[i]->setText(tr("Standart-Parameter der DSP-Software","Option Dialog"));
    estandardparameterfilename[i] = new QLineEdit(wstar[i]);
    estandardparameterfilename[i]->setGeometry(10,yp+25,320,30);
    bstandardparameterfilename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    bstandardparameterfilename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( bstandardparameterfilename[i], SIGNAL(clicked()), this, SLOT(clickbstandardparameterfilename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    lrxeqfilename[i] = new QLabel(wstar[i]);
    lrxeqfilename[i]->setGeometry(10,yp,320,30);
    lrxeqfilename[i]->setText(tr("RX-Equalizer der DSP-Software","Option Dialog"));
    erxeqfilename[i] = new QLineEdit(wstar[i]);
    erxeqfilename[i]->setGeometry(10,yp+25,320,30);
    brxeqfilename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    brxeqfilename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( brxeqfilename[i], SIGNAL(clicked()), this, SLOT(clickbrxeqfilename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ltxeqfilename[i] = new QLabel(wstar[i]);
    ltxeqfilename[i]->setGeometry(10,yp,320,30);
    ltxeqfilename[i]->setText(tr("TX-Equalizer der DSP-Software","Option Dialog"));
    etxeqfilename[i] = new QLineEdit(wstar[i]);
    etxeqfilename[i]->setGeometry(10,yp+25,320,30);
    btxeqfilename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    btxeqfilename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( btxeqfilename[i], SIGNAL(clicked()), this, SLOT(clickbtxeqfilename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    lscalfilename[i] = new QLabel(wstar[i]);
    lscalfilename[i]->setGeometry(10,yp,320,30);
    lscalfilename[i]->setText(tr("S-Meter Kalibrierung DSP-Software","Option Dialog"));
    escalfilename[i] = new QLineEdit(wstar[i]);
    escalfilename[i]->setGeometry(10,yp+25,320,30);
    bscalfilename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    bscalfilename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( bscalfilename[i], SIGNAL(clicked()), this, SLOT(clickbscalfilename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    yp += abstand;
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ltestfilename[i] = new QLabel(wstar[i]);
    ltestfilename[i]->setGeometry(10,yp,320,30);
    ltestfilename[i]->setText(tr("Testfirmware fuer den DSP","Option Dialog"));
    etestfilename[i] = new QLineEdit(wstar[i]);
    etestfilename[i]->setGeometry(10,yp+25,320,30);
    btestfilename[i] = new QPushButton(tr("...","Option Dialog"), wstar[i]);
    btestfilename[i]->setGeometry(340,yp+25,30,30);
    QObject::connect( btestfilename[i], SIGNAL(clicked()), this, SLOT(clickbtestfilename()));
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  }
};


void odlg::setdaten(TEinstellungen aeinst){
  QString s;
  
  oeinst = aeinst;
  crs232->setEditText(oeinst.srs232);
  sppicrs232wtime->setValue(oeinst.picrs232writetime);
  spdsprs232wtime->setValue(oeinst.dsprs232writetime);
  spparamrs232wtime->setValue(oeinst.paramrs232writetime);
  for(int i=0; i<3; i++){
    estarpfad[i]->setText(oeinst.starpfad[i]);
    edspcodefilename[i]->setText(oeinst.dspcodefilename[i]);
    efilterfilename[i]->setText(oeinst.filterfilename[i]);
    ead603filename[i]->setText(oeinst.ad603filename[i]);
    eparameterfilename[i]->setText(oeinst.parameterfilename[i]);
    exparameterfilename[i]->setText(oeinst.xparameterfilename[i]);
    estandardparameterfilename[i]->setText(oeinst.standardparameterfilename[i]);
    erxeqfilename[i]->setText(oeinst.rxeqfilename[i]);
    etxeqfilename[i]->setText(oeinst.txeqfilename[i]);
    escalfilename[i]->setText(oeinst.scalfilename[i]);
    etestfilename[i]->setText(oeinst.testfilename[i]);
  }
};

TEinstellungen odlg::getdaten(){
  QString s;
  oeinst.srs232 = crs232->currentText();
  oeinst.picrs232writetime = sppicrs232wtime->value();
  oeinst.dsprs232writetime = spdsprs232wtime->value();
  oeinst.paramrs232writetime = spparamrs232wtime->value();
  for(int i=0; i<3; i++){
    oeinst.starpfad[i] = estarpfad[i]->text();
    oeinst.dspcodefilename[i] = edspcodefilename[i]->text();
    oeinst.filterfilename[i] = efilterfilename[i]->text();
    oeinst.ad603filename[i] = ead603filename[i]->text();
    oeinst.parameterfilename[i] = eparameterfilename[i]->text();
    oeinst.xparameterfilename[i] = exparameterfilename[i]->text();
    oeinst.standardparameterfilename[i] = estandardparameterfilename[i]->text();
    oeinst.rxeqfilename[i] = erxeqfilename[i]->text();
    oeinst.txeqfilename[i] = etxeqfilename[i]->text();
    oeinst.scalfilename[i] = escalfilename[i]->text();
    oeinst.testfilename[i] = etestfilename[i]->text();
  }
  return oeinst;
};

void odlg::clickbstarpfad(){
  #ifdef Q_WS_WIN
  QString slash = "\\";
  #else
  QString slash = "/";
  #endif
  QDir dir;
  
  int idx = tabwidget->currentIndex()-1;
  qDebug("idx %i",idx);
  QString qs = QFileDialog::getExistingDirectory(this, tr("Verzeichnisauswahl","Option"), oeinst.starpfad[idx]);
  //
  if(! qs.isEmpty()){
    estarpfad[idx]->setText(qs);
    oeinst.starpfad[idx] = qs;
    dir = oeinst.starpfad[idx] + slash + "STAR2b1x.xjp";
    //qDebug(qPrintable(dir.absolutePath()));
    if(QFile::exists(dir.absolutePath()))edspcodefilename[idx]->setText(dir.absolutePath());
    dir = oeinst.starpfad[idx] + slash + "Filters" + slash + "filters.xjp";
    if(QFile::exists(dir.absolutePath()))efilterfilename[idx]->setText(dir.absolutePath());
    dir = oeinst.starpfad[idx] + slash + "Filters" + slash + "AD603.dat";
    if(QFile::exists(dir.absolutePath()))ead603filename[idx]->setText(dir.absolutePath());
    dir = oeinst.starpfad[idx] + slash + "USER2B2.XJP";
    if(QFile::exists(dir.absolutePath()))eparameterfilename[idx]->setText(dir.absolutePath());
    dir = oeinst.starpfad[idx] + slash + "Filters" + slash + "Xparams.xjp";
    if(QFile::exists(dir.absolutePath()))exparameterfilename[idx]->setText(dir.absolutePath());
    dir = oeinst.starpfad[idx] + slash + "standard.xjp";
    if(QFile::exists(dir.absolutePath()))estandardparameterfilename[idx]->setText(dir.absolutePath());
    dir = oeinst.starpfad[idx] + slash + "Filters" + slash + "Scal.dat";
    if(QFile::exists(dir.absolutePath()))escalfilename[idx]->setText(dir.absolutePath());
    dir = oeinst.starpfad[idx] + slash + "Test05.xjp";
    if(QFile::exists(dir.absolutePath()))etestfilename[idx]->setText(dir.absolutePath());
    dir = oeinst.starpfad[idx] + slash + "Filters" + slash + "RxEQ.dat";
    if(QFile::exists(dir.absolutePath()))erxeqfilename[idx]->setText(dir.absolutePath());
    dir = oeinst.starpfad[idx] + slash + "Filters" + slash + "TxEQ.dat";
    if(QFile::exists(dir.absolutePath()))etxeqfilename[idx]->setText(dir.absolutePath());
  }
}

void odlg::clickbdspcodefilename(){
  int idx = tabwidget->currentIndex()-1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl","Option"), oeinst.starpfad[idx], "DSP-Software (*.xjp *.XJP);;"
                                                                                                  "Alle Dateien (*.*)");
  if(! qs.isEmpty())edspcodefilename[idx]->setText(qs);
}

void odlg::clickbfilterfilename(){
  int idx = tabwidget->currentIndex()-1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl","Option"), oeinst.starpfad[idx], "DSP-Daten (*.xjp *.XJP);;"
                                                                                                  "Alle Dateien (*.*)");
  if(!qs.isEmpty())efilterfilename[idx]->setText(qs);
}

void odlg::clickbad603filename(){
  int idx = tabwidget->currentIndex()-1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl","Option"), oeinst.starpfad[idx], "AD603-Daten (*.dat *.DAT);;"
                                                                                                  "Alle Dateien (*.*)");
  if(!qs.isEmpty())ead603filename[idx]->setText(qs);
}

void odlg::clickbparameterfilename(){
  int idx = tabwidget->currentIndex()-1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl","Option"), oeinst.starpfad[idx], "DSP-Daten (*.xjp *.XJP);;"
                                                                                                  "Alle Dateien (*.*)");
  if(!qs.isEmpty())eparameterfilename[idx]->setText(qs);
}

void odlg::clickbxparameterfilename(){
  int idx = tabwidget->currentIndex()-1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl","Option"), oeinst.starpfad[idx], "X-Paramter (*.xjp *.XJP);;"
                                                                                                  "Alle Dateien (*.*)");
  if(!qs.isEmpty())exparameterfilename[idx]->setText(qs);
}

void odlg::clickbstandardparameterfilename(){
  int idx = tabwidget->currentIndex() - 1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl","Option"), oeinst.starpfad[idx], "DSP-Daten (*.xjp *.XJP);;"
                                                                                                  "Alle Dateien (*.*)");
  if(!qs.isEmpty())estandardparameterfilename[idx]->setText(qs);
}

void odlg::clickbscalfilename(){
  int idx = tabwidget->currentIndex() - 1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl","Option"), oeinst.starpfad[idx], "DSP-Daten (*.dat *.DAT);;"
                                                                                                  "Alle Dateien (*.*)");
  if(!qs.isEmpty())escalfilename[idx]->setText(qs);
}

void odlg::clickbtestfilename(){
  int idx = tabwidget->currentIndex() - 1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl","Option"), oeinst.starpfad[idx], "DSP-Daten (*.xjp *.XJP);;"
                                                                                                  "Alle Dateien (*.*)");
  if(!qs.isEmpty())etestfilename[idx]->setText(qs);
}

void odlg::clickbrxeqfilename(){
  int idx = tabwidget->currentIndex() - 1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl RX-Equalizer","Option"), oeinst.starpfad[idx], "DSP-Daten (*.dat *.DAT);;"
                                                                                                  "Alle Dateien (*.*)");
  if(!qs.isEmpty())erxeqfilename[idx]->setText(qs);
}

void odlg::clickbtxeqfilename(){
  int idx = tabwidget->currentIndex() - 1;
  QString qs = QFileDialog:: getOpenFileName(this, tr("Dateisauswahl TX-Equalizer","Option"), oeinst.starpfad[idx], "DSP-Daten (*.dat *.DAT);;"
                                                                                                  "Alle Dateien (*.*)");
  if(!qs.isEmpty())etxeqfilename[idx]->setText(qs);
}

void odlg::tip(bool btip)
{
  if(btip){
  }else{
  }
}
