/**************************************************************************
*   Copyright (C) 2009 by Andreas Lindenau                                *
*   DL4JAL@darc.de                                                        *
***************************************************************************
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include <QtGui>
#include <cmath>
#include <QtGlobal>
#include <QString>
#include <QProgressBar>
#include <QProgressDialog>

#include "starcat.h"
#include "configfile.h"


starcat::starcat()
{
  version = "V1.18";
  verdatum = " vom 17.11.2014";

///////////////////////////////////////////////////////////////////////////////
//Schnittstelle zum NWT7 erzeugen erzeugen fuer alle Widgets
//  picmodem = new QextSerialPort("/dev/ttyS0");
//  delete picmodem;
  picmodem = new Modem();
//  picmodem->opentty(weichen.str_tty);
  QObject::connect( picmodem, SIGNAL(setTtyText(QString)), this, SLOT(setAText(QString)));
//  bttyOpen = picmodem->opentty(weichen.str_tty);
///////////////////////////////////////////////////////////////////////////////
  
  testtimer = new QTimer(this);
  QObject::connect(testtimer, SIGNAL(timeout()), this, SLOT(testtimerstop()));

  repainttimer = new QTimer(this);
  QObject::connect(repainttimer, SIGNAL(timeout()), this, SLOT(actrepainttimer()));
  repainttimer->start(1);

  timerdspbef = new QTimer(this);
  QObject::connect( timerdspbef, SIGNAL(timeout()), this, SLOT(tstopdspbef()));
  timerdspbef->stop();

  timersmbef = new QTimer(this);
  QObject::connect( timersmbef, SIGNAL(timeout()), this, SLOT(tstopsmbef()));
  timersmbef->stop();

  timerempfangRS232 = new QTimer(this);
  QObject::connect( timerempfangRS232, SIGNAL(timeout()), this, SLOT(tstopempfangRS232()));
  timerempfangRS232->stop();

  timerrxeq = new QTimer(this);
  QObject::connect( timerrxeq, SIGNAL(timeout()), this, SLOT(timerrxeqstop()));
  timerrxeq->stop();

  timertxeq = new QTimer(this);
  QObject::connect( timertxeq, SIGNAL(timeout()), this, SLOT(timertxeqstop()));
  timertxeq->stop();

  timerdspmoni = new QTimer(this);
  QObject::connect( timerdspmoni, SIGNAL(timeout()), this, SLOT(timerdspmonistop()));
  timerdspmoni->stop();
  
  awidget = new QTabWidget();
  //awidget->setTabPosition(QTabWidget::East);
  setCentralWidget(awidget);
  setMinimumSize (600, 480);
  
  wstarcat = new QWidget();
  awidget->addTab(wstarcat, tr("DSP-Firmware","TabWindow"));
  
  //buttonfileladen = new QPushButton("Alle DSP-Dateien lesen", wstarcat);
  //QObject::connect( buttonfileladen, SIGNAL(clicked()), this, SLOT(clickfileladen()));
  
  gdspg3xjp = new QGroupBox("PicAStar (G3XJP + DL4JAL)", wstarcat);
  //gdspg3xjp->setEnabled(FALSE);
  
  buttondspladen = new QPushButton(tr("Direkt zum DSP"), gdspg3xjp);
  QObject::connect( buttondspladen, SIGNAL(clicked()), this, SLOT(clickdspladen()));
  
  buttonpicladen = new QPushButton(tr("Daten + Parameter zum PIC"), gdspg3xjp);
  QObject::connect( buttonpicladen, SIGNAL(clicked()), this, SLOT(clickpicladen()));
  
  buttonpar2pic = new QPushButton(tr("Nur Parameter zum PIC"), gdspg3xjp);
  QObject::connect( buttonpar2pic, SIGNAL(clicked()), this, SLOT(clickpar2pic()));
  
  gdspdl4jal = new QGroupBox(tr("PicAStar (nur DL4JAL)"), wstarcat);
  //gdspdl4jal->setEnabled(FALSE);
  //gdspdl4jal->hide();
  
  buttoneesichern = new QPushButton(tr("Eeprom Sicherung"), gdspdl4jal);
  QObject::connect( buttoneesichern, SIGNAL(clicked()), this, SLOT(clickeesichern()));
  
  buttoneerestore = new QPushButton(tr("Eeprom Wiederherstellung"), gdspdl4jal);
  QObject::connect( buttoneerestore, SIGNAL(clicked()), this, SLOT(clickeerestore()));
  
  buttonparam2pc = new QPushButton(tr("Parameter Star -> PC"), gdspdl4jal);
  QObject::connect( buttonparam2pc, SIGNAL(clicked()), this, SLOT(clickparam2pc()));

  //buttonpar2pic = new QPushButton("Nur Parameterzum PIC", gdspdl4jal);
  //QObject::connect( buttonpar2pic, SIGNAL(clicked()), this, SLOT(clickpar2pic()));
  
  gtestladen = new QGroupBox(tr("Testprogramm zum DSP"), wstarcat);
  buttontestladen = new QPushButton(tr("Testsoftware"), gtestladen);
  QObject::connect( buttontestladen, SIGNAL(clicked()), this, SLOT(clicktestladen()));
  //buttontest = new QPushButton("+", gtestladen);
  //QObject::connect( buttontest, SIGNAL(clicked()), this, SLOT(btest()));

  gdspbefehl = new QGroupBox(tr("Befehl direkt zum DSP"), wstarcat);
  buttondspbefehl = new QPushButton(tr("DSP-Befehl"), gdspbefehl);
  QObject::connect( buttondspbefehl, SIGNAL(clicked()), this, SLOT(clickdspbefehl()));
  
  dspid = new QLineEdit(gdspbefehl);
  dspwert = new QLineEdit(gdspbefehl);
  
  textinfo = new QTextEdit(wstarcat);
  //default setzen
  paramkopf1 = "";
  paramkopf2 = "";
  
  wdspparam = new QWidget();
  awidget->addTab(wdspparam, tr("DSP-Parameter","TabWindow"));
  QString qs;
  
  buttonfileladen1 = new QPushButton(tr("Parameter laden"), wdspparam);
  QObject::connect( buttonfileladen1, SIGNAL(clicked()), this, SLOT(clickparamladen()));
  
  buttonparamsave = new QPushButton(tr("Parameter speichern"), wdspparam);
  QObject::connect( buttonparamsave, SIGNAL(clicked()), this, SLOT(clickparamsave()));
  
  buttonxparamladen = new QPushButton(tr("X-Parameter laden"), wdspparam);
  QObject::connect( buttonxparamladen, SIGNAL(clicked()), this, SLOT(clickxparamladen()));
  
  buttonxparamsave = new QPushButton(tr("X-Parameter speichern"), wdspparam);
  QObject::connect( buttonxparamsave, SIGNAL(clicked()), this, SLOT(clickxparamsave()));
  buttonxparamsave->setEnabled(FALSE);
  
  cbdmoni = new QCheckBox(tr("DSP Monitor"),wdspparam);
  QObject::connect(cbdmoni, SIGNAL(stateChanged(int)), this, SLOT(setdmoni()));
  cbdmoni->setEnabled(FALSE);

  dsptabwidget = new QTabWidget(wdspparam);
  for(int i=0; i<3; i++){
    wdsp[i] = new QWidget();
    qs.sprintf("%i - %i - %i", i*3+1, i*3+2, i*3+3 );
    dsptabwidget->addTab(wdsp[i], qs);
  }
  int j;
  for(int i=0; i<100; i++){
    j = (i+20)/30-1;
    if(j < 0)j = 0;
    //qDebug("%i",j);
    ldspparam[i] = new QLabel(wdsp[j]);
    dspparam[i] = new QDoubleSpinBox(wdsp[j]);
    lparambeschr[i] = new QLabel(wdsp[j]);
    if(i<10){
      dspparam[i]->hide();
      ldspparam[i]->hide();
      lparambeschr[i]->hide();
    }
    if(i%10 == 0){
      dspparam[i]->hide();
      ldspparam[i]->hide();
      lparambeschr[i]->hide();
    }
    dspparam[i]->setRange(0.0,255.0);
    dspparam[i]->setValue(255.0);
    dspparam[i]->setDecimals(0);
    QObject::connect(dspparam[i], SIGNAL(valueChanged(double)), this, SLOT(dspbefehl()));
  }
  setuserid();
  
  b1 = new QCheckBox(tr("1 Denoiser"), wdspparam);
  QObject::connect(b1, SIGNAL(stateChanged(int)), this, SLOT(setb1()));
  b2 = new QCheckBox(tr("2 Mute"), wdspparam);
  QObject::connect(b2, SIGNAL(stateChanged(int)), this, SLOT(setb2()));
  b3 = new QCheckBox(tr("3 Noise Bl."), wdspparam);
  QObject::connect(b3, SIGNAL(stateChanged(int)), this, SLOT(setb3()));
  b4 = new QCheckBox(tr("4 A-Notch"), wdspparam);
  QObject::connect(b4, SIGNAL(stateChanged(int)), this, SLOT(setb4()));
  b5 = new QCheckBox(tr("5 M-Notch"), wdspparam);
  QObject::connect(b5, SIGNAL(stateChanged(int)), this, SLOT(setb5()));
  b6 = new QCheckBox(tr("6 Fil.6.2"), wdspparam);
  QObject::connect(b6, SIGNAL(stateChanged(int)), this, SLOT(setb6()));
  b7 = new QCheckBox(tr("7 VOX"), wdspparam);
  QObject::connect(b7, SIGNAL(stateChanged(int)), this, SLOT(setb7()));
  b9 = new QCheckBox(tr("9 RF Clip"), wdspparam);
  QObject::connect(b9, SIGNAL(stateChanged(int)), this, SLOT(setb9()));
  
  gparam = new QGroupBox(tr("Parameterbank"),wdspparam);
  rbgn = new QRadioButton(tr("Gruen"), gparam);
  QObject::connect(rbgn, SIGNAL(pressed()), this, SLOT(setparamgruppegn()));
  rbge = new QRadioButton(tr("Gelb"), gparam);
  QObject::connect(rbge, SIGNAL(pressed()), this, SLOT(setparamgruppege()));
  rbrt = new QRadioButton(tr("Rot"), gparam);
  QObject::connect(rbrt, SIGNAL(pressed()), this, SLOT(setparamgruppert()));
  
  gseitenband = new QGroupBox(tr("Seitenband"),wdspparam);
  rbusb = new QRadioButton(tr("USB"), gseitenband);
  QObject::connect(rbusb, SIGNAL(pressed()), this, SLOT(setparamusb()));
  rblsb = new QRadioButton(tr("LSB"), gseitenband);
  QObject::connect(rblsb, SIGNAL(pressed()), this, SLOT(setparamlsb()));
  
  gmode = new QGroupBox(tr("Mode"),wdspparam);
  rbssb = new QRadioButton(tr("SSB"), gmode);
  QObject::connect(rbssb, SIGNAL(pressed()), this, SLOT(setparamgruppessb()));
  rbcw = new QRadioButton(tr("CW"), gmode);
  QObject::connect(rbcw, SIGNAL(pressed()), this, SLOT(setparamgruppecw()));

  gbefehlsid = new QGroupBox(tr("DSP-ID"),wdspparam);
  rbuser = new QRadioButton(tr("User"), gbefehlsid);
  QObject::connect(rbuser, SIGNAL(pressed()), this, SLOT(setuserid()));
  rbstar = new QRadioButton(tr("Star"), gbefehlsid);
  QObject::connect(rbstar, SIGNAL(pressed()), this, SLOT(setstarid()));

  paramSetEnabled(FALSE);
  
  wrxeq = new QWidget();
  awidget->addTab(wrxeq, tr("RX-Equalizer","TabWindow"));
  grxeq = new QGroupBox(tr("Equalizer RX"),wrxeq);
  grxeq->setEnabled(FALSE);
  for(int i=0; i<31; i++){
    slrx[i] = new QSlider(Qt::Vertical, grxeq);
    QObject::connect(slrx[i], SIGNAL(valueChanged(int)), this, SLOT(rxslideraendern()));
    slrx[i]->setRange(-13,0);
    slrx[i]->setValue(0);
    rxvalue[i]= 0;
    rxvaluealt[i]= 0;
    qs.sprintf("%i",i+1);
    slrxlabel3[i] = new QLabel(qs,grxeq);
    slrxlabel4[i] = new QLabel(qs,grxeq);
  }
  slrxlabel3[31] = new QLabel("(x100Hz)",grxeq);
  slrxlabel4[31] = new QLabel("(x100Hz)",grxeq);
  for(int i=0; i<14; i++){
    qs.sprintf("%idB",i*-1);
    if(i==13)qs="-90dB";
    slrxlabel1[i] = new QLabel(qs,grxeq);
    slrxlabel2[i] = new QLabel(qs,grxeq);
  }
  buttonrxeqladen = new QPushButton(tr("RX-Datei laden"), wrxeq);
  QObject::connect( buttonrxeqladen, SIGNAL(clicked()), this, SLOT(clickrxeqladen()));
  buttonrxeqspeichern = new QPushButton(tr("RX-Datei speichern"), wrxeq);
  buttonrxeqspeichern->setEnabled(FALSE);
  QObject::connect( buttonrxeqspeichern, SIGNAL(clicked()), this, SLOT(clickrxeqspeichern()));
  buttonrxeq2pic = new QPushButton(tr("Zum \"Star\" direkt"), wrxeq);
  buttonrxeq2pic->setEnabled(FALSE);
  QObject::connect( buttonrxeq2pic, SIGNAL(clicked()), this, SLOT(clickrxeq2pic()));
  lrxstatus= new QLabel("", wrxeq);
  rxeqdateigeladen = FALSE;

  wtxeq = new QWidget();
  awidget->addTab(wtxeq, tr("TX-Equalizer","TabWindow"));
  gtxeq = new QGroupBox(tr("Equalizer TX"),wtxeq);
  gtxeq->setEnabled(FALSE);
  for(int i=0; i<31; i++){
    sltx[i] = new QSlider(Qt::Vertical, gtxeq);
    QObject::connect(sltx[i], SIGNAL(valueChanged(int)), this, SLOT(txslideraendern()));
    sltx[i]->setRange(-13,0);
    sltx[i]->setValue(0);
    txvalue[i]= 0;
    txvaluealt[i]= 0;
    qs.sprintf("%i",i+1);
    sltxlabel3[i] = new QLabel(qs,gtxeq);
    sltxlabel4[i] = new QLabel(qs,gtxeq);
  }
  sltxlabel3[31] = new QLabel("(x100Hz)",gtxeq);
  sltxlabel4[31] = new QLabel("(x100Hz)",gtxeq);
  for(int i=0; i<14; i++){
    qs.sprintf("%idB",i*-1);
    if(i==13)qs="-90dB";
    sltxlabel1[i] = new QLabel(qs,gtxeq);
    sltxlabel2[i] = new QLabel(qs,gtxeq);
  }
  buttontxeqladen = new QPushButton(tr("TX-Datei laden"), wtxeq);
  QObject::connect( buttontxeqladen, SIGNAL(clicked()), this, SLOT(clicktxeqladen()));
  buttontxeqspeichern = new QPushButton(tr("TX-Datei speichern"), wtxeq);
  buttontxeqspeichern->setEnabled(FALSE);
  QObject::connect( buttontxeqspeichern, SIGNAL(clicked()), this, SLOT(clicktxeqspeichern()));
  buttontxeq2pic = new QPushButton(tr("Zum \"Star\" direkt"), wtxeq);
  buttontxeq2pic->setEnabled(FALSE);
  QObject::connect( buttontxeq2pic, SIGNAL(clicked()), this, SLOT(clicktxeq2pic()));
  ltxstatus = new QLabel("", wtxeq);
  txeqdateigeladen = FALSE;

  //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  wifcal = new QWidget();
  awidget->addTab(wifcal, tr("ZF-Kalibrierung (AD603)","TabWindow"));
  pbagc = new QProgressBar(wifcal);
  pbagc->setFormat("%vdB");
  pbagc->setRange(0,90);
  pbagc->setValue(0);
  stepinfo = new QTextEdit(wifcal);

  buttonifstep = new QPushButton(tr("START"), wifcal);
  QObject::connect( buttonifstep, SIGNAL(clicked()), this, SLOT(clickifstep()));
  buttonifabbruch = new QPushButton(tr("ABBRUCH"), wifcal);
  QObject::connect( buttonifabbruch, SIGNAL(clicked()), this, SLOT(clickifabbruch()));
  lpbagc = new QLabel(tr("Pegelanzeige der Messungen"), wifcal);
  initstepinfo();
  //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  wsmcal = new QWidget();
  awidget->addTab(wsmcal, tr("S-Meter-Kalibrierung","TabWindow"));
  pbsmagc = new QProgressBar(wsmcal);
  pbsmagc->setFormat("%vdB");
  pbsmagc->setRange(0,90);
  pbsmagc->setValue(0);
  stepsminfo = new QTextEdit(wsmcal);

  buttonsmstep = new QPushButton(tr("START"), wsmcal);
  QObject::connect( buttonsmstep, SIGNAL(clicked()), this, SLOT(clicksmstep()));
  buttonsmabbruch = new QPushButton(tr("ABBRUCH"), wsmcal);
  QObject::connect( buttonsmabbruch, SIGNAL(clicked()), this, SLOT(clicksmabbruch()));
  lpbsmagc = new QLabel(tr("Pegelanzeige der Messungen"), wsmcal);
  initstepsminfo();
  
  strsm <<">29MHz"<<"10m"<<"12m"<<"15m"<<"17m"<<"60m"<<"20m"<<"30m"<<"40m"<<"80m"<<"160m";
  strsm <<"IP3"<<"NF"<<"DDS72"<<"DDS43"<<"DDS23"<<"DDS79"<<"dB";
  grsm = new QGroupBox(tr("Kalibriereinstellungen"),wsmcal);
  for(int i=0; i<18; i++){
    lsm[i] = new QLabel(strsm.at(i),grsm);
  }
  for(int i=0; i<11; i++){
    slip3[i] = new QSpinBox(grsm);
    slip3[i]->setRange(70,190);
    slip3[i]->setValue(135);
    slip3[i]->setSingleStep(1);
    QObject::connect(slip3[i], SIGNAL(valueChanged(int)), this, SLOT(geaendertsm()));
    slnf[i] = new QSpinBox(grsm);
    slnf[i]->setRange(70,190);
    slnf[i]->setValue(135);
    slnf[i]->setSingleStep(1);
    QObject::connect(slnf[i], SIGNAL(valueChanged(int)), this, SLOT(geaendertsm()));
    dslip3[i] = 0;
    dslnf[i] = 0;
  }
  for(int i=0; i<4; i++){
    sldds[i] = new QSpinBox(grsm);
    sldds[i]->setRange(-50,50);
    sldds[i]->setValue(0);
    sldds[i]->setSingleStep(1);
    QObject::connect(sldds[i], SIGNAL(valueChanged(int)), this, SLOT(geaendertsm()));
    dsldds[i] = 0;
  }
  sldds[0]->setValue(-20);
  dsldds[0] = -20;
  grsm->setEnabled(FALSE); //noch keine Daten geladen
  //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  // DSP Monitor

  dmoni = new DspMonitor();
  QObject::connect(this, SIGNAL(sendedspdaten(const TDspDaten &)), dmoni, SLOT(getdspdaten(const TDspDaten &)));
  dmoni->hide();
  //awidget->addTab(dmoni, tr("DSP Monitor","TabWindow"));

  // DSP Monitor
  //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

  dlgeinst = new odlg();
  dlgeinst->setAttribute(Qt::WA_QuitOnClose);
  QObject::connect( dlgeinst, SIGNAL(accepted()), this, SLOT(meinstsave()));
  
  createActions();
  createMenus();
  createToolBars();
  createStatusBar();

  awidget->setEnabled(TRUE);

  homedir = QDir::home();
  if(!homedir.cd("starcat")){
    //Befindet sich im HOME kein starcat-Verzeichnis
    //starcat erzeugen
    homedir.mkdir("starcat");
    //in das starcat gehen
    homedir.cd("starcat");
  }

  readSettings();
  cfgladen();
  grafiksetzen();
  param_geladen = FALSE;
  sm_geladen = FALSE;
  bdateifehler = FALSE;
  bsmparam = FALSE;
  bparamgeaendert = FALSE;
  bxparamgeaendert = FALSE;
  //Grundeinstellung
  //starnr = 0;//HW1
  //auswahlstar1();//HW1
  dspbufferloeschen();
  parameterloeschen();

}

void starcat::meinst()
{
  dlgeinst->setdaten(einst);
  dlgeinst->exec();
  setHWText();
}

void starcat::meinstsave()
{
  einst = dlgeinst->getdaten();
  cfgspeichern();
  picmodem->closetty();
  rs232isopen = picmodem->opentty(einst.srs232);
  if(!rs232isopen){
    QMessageBox::about(this, tr("Einstellungen"),tr("Die RS232 laesst sich nicht oeffnen!"));
  }
  this->setFocus();
}

void starcat::setTextWindow(){
  QString qs;
  QString stty;
  if(rs232isopen)stty = einst.srs232; else stty = "?";
  qs = tr("PicAStar-Loader");
  QString astty = qs + " - " + version + " - " + stty + " - " + einst.starpfad[starnr];
  setWindowTitle(astty);
}

void starcat::setAText(QString stty){
  QString qs;
  qs = tr("PicAStar-Loader");
  QString astty = qs + " - " + version + " - " + stty + " - " + einst.starpfad[starnr];
  setWindowTitle(astty);
}

void starcat::closeEvent(QCloseEvent *event)
{
  cfgspeichern();
  writeSettings();
  DSPcommando(52,1);
  if(timerdspmoni->isActive())timerdspmoni->stop();
  if(timertxeq->isActive())timertxeq->stop();
  if(timerrxeq->isActive())timerrxeq->stop();
  if(timerempfangRS232->isActive())timerempfangRS232->stop();
  if(timersmbef->isActive())timersmbef->stop();
  if(timerdspbef->isActive())timerdspbef->stop();
  picmodem->closetty();
  if(picmodem != NULL){delete picmodem; picmodem = NULL;}
  if(dmoni != NULL){delete dmoni; dmoni = NULL;}
  event->accept();
}

void starcat::about()
{
  QString qs = tr("<b>Diese Applikation dient der Aufbereitung<br>"
                  "der DSP-Firmware des TRX-PicAStar</b><br>"
                  "Es wird die HW von G3XJP und die<br>" 
                  "HW von DL4JAL (LCD 4x20 Char)<br>" 
                  "unterstuetzt.<br><br> ")
                  +version+verdatum+"<br> (c) DL4JAL";

  QMessageBox::about(this, tr("PicAStar-Loader"), qs);
}

void starcat::createActions()
{
  exitAct = new QAction(QIcon(":/beenden.xpm"),tr("&Beenden"), this);
  exitAct->setStatusTip(tr("Programm beenden"));
  connect(exitAct, SIGNAL(triggered()), this, SLOT(close()));

  einstAct = new QAction(QIcon(":/option.png"),tr("&Einstellungen"), this);
  einstAct->setStatusTip(tr("Grundeinstellungen"));
  connect(einstAct, SIGNAL(triggered()), this, SLOT(meinst()));

  aboutAct = new QAction(QIcon(":/info.png"),tr("&Ueber"), this);
  aboutAct->setStatusTip(tr("Ueber die Applikation"));
  connect(aboutAct, SIGNAL(triggered()), this, SLOT(about()));

  aboutQtAct = new QAction(tr("Ueber &Qt"), this);
  aboutQtAct->setStatusTip(tr("Show the Qt library's About box"));
  connect(aboutQtAct, SIGNAL(triggered()), qApp, SLOT(aboutQt()));

  star1Act = new QAction(tr("PicAStar HW1"),this);
  star1Act->setStatusTip(tr("Auswahl des PicAStar1"));
  star1Act->setIconText(tr("PicAStar HW1"));
  star1Act->setCheckable(true);
  connect(star1Act, SIGNAL(triggered()), this, SLOT(auswahlstar1()));
  star2Act = new QAction(tr("PicAStar HW2"), this);
  star2Act->setStatusTip(tr("Auswahl des PicAStar2"));
  star2Act->setIconText(tr("PicAStar HW2"));
  star2Act->setCheckable(true);
  connect(star2Act, SIGNAL(triggered()), this, SLOT(auswahlstar2()));
  star3Act = new QAction(tr("PicAStar HW3"), this);
  star3Act->setStatusTip(tr("Auswahl des PicAStar3"));
  star3Act->setIconText(tr("PicAStar HW3"));
  star3Act->setCheckable(true);
  connect(star3Act, SIGNAL(triggered()), this, SLOT(auswahlstar3()));
}

void starcat::createMenus()
{
  fileMenu = menuBar()->addMenu(tr("&Datei"));
  fileMenu->addSeparator();
  fileMenu->addAction(exitAct);
  
  optionMenu = menuBar()->addMenu(tr("&Einstellungen"));
  optionMenu->addAction(einstAct);

  menuBar()->addSeparator();

  helpMenu = menuBar()->addMenu(tr("&Hilfe"));
  helpMenu->addAction(aboutAct);
  helpMenu->addAction(aboutQtAct);
  
  starMenu = menuBar()->addMenu(tr("&Star Auswahl"));
  starMenu->addAction(star1Act);
  starMenu->addAction(star2Act);
  starMenu->addAction(star3Act);
}

void starcat::createToolBars()
{
  fileToolBar = addToolBar(tr("File"));
  fileToolBar->addAction(exitAct);
  fileToolBar->addAction(einstAct);
  fileToolBar->addAction(aboutAct);
  fileToolBar->addAction(star1Act);
  fileToolBar->addAction(star2Act);
  fileToolBar->addAction(star3Act);
}

void starcat::createStatusBar()
{
  statusBar()->showMessage(tr("Ready"));
}

void starcat::readSettings()
{
  QSettings settings("AFU", "starcat");
  QPoint pos = settings.value("pos", QPoint(200, 200)).toPoint();
  QSize size = settings.value("size", QSize(400, 400)).toSize();
  QPoint monipos = settings.value("monipos", QPoint(50, 50)).toPoint();
  QSize monisize = settings.value("monisize", QSize(530, 290)).toSize();
  move(pos);
  resize(size);
  dmoni->move(monipos);
  if(monisize.width() < 530)monisize.setWidth(530);
  if(monisize.height() < 290)monisize.setHeight(290);
  dmoni->resize(monisize);
}

void starcat::writeSettings()
{
  QSettings settings("AFU", "starcat");
  settings.setValue("pos", pos());
  settings.setValue("size", size());
  settings.setValue("monipos", dmoni->pos());
  settings.setValue("monisize", dmoni->size());
}


starcat::~starcat()
{
  if(picmodem != NULL){
    delete picmodem;
    picmodem = NULL;
  }
  if(dmoni != NULL){
    delete dmoni;
    dmoni = NULL;
  }
}

bool starcat::defaultlesenrtty(){
  char abuffer[256];
  int a=0;

  if (rs232isopen){
    a = picmodem->readttybuffer(abuffer, 256);
    return a > 0;
  }
  return false;
}

void starcat::resizeEvent( QResizeEvent * ){
  //nach Groessenaenderung grafische Elemente anpassen
  resize(this->rect().size());
  grafiksetzen();
  //qDebug("breite %i hoehe %i", gsize.width(), gsize.height());
}

void starcat::repaintEvent( QPaintEvent * ){
  //nach Groessenaenderung grafische Elemente anpassen
  //qDebug("breite %i hoehe %i", width(), height());
  grafiksetzen();
  QWidget::repaint();
}

void starcat::grafiksetzen(){
//  QSize gsize = wstarcat->size();
//  grafik->resize(gsize);
//  grafik->setParameterPixmap();

  //int w = wstarcat->width();
  int h = wstarcat->height();
  //buttonfileladen->setGeometry(40, 40, 200, 30);
  
  gdspg3xjp->setGeometry(20, 40, 250, 150);
  buttondspladen->setGeometry(20, 20, 200, 30);
  buttonpicladen->setGeometry(20, 60, 200, 30);
  buttonpar2pic->setGeometry(20, 100, 200, 30);
  
  gdspdl4jal->setGeometry(20, 200, 250, 140);
  buttoneesichern->setGeometry(20, 20, 200, 30);
  buttoneerestore->setGeometry(20, 60, 200, 30);
  buttonparam2pc->setGeometry(20, 100, 200, 30);

  gdspbefehl->setGeometry(20, 380, 250, 100);
  buttondspbefehl->setGeometry(20, 20, 200, 30);
  dspid->setGeometry(20, 60, 40, 30);
  dspwert->setGeometry(70, 60, 40, 30);
  
  gtestladen->setGeometry(20, 500, 250, 70);
  buttontestladen->setGeometry(20, 20, 200, 30);
  //buttontest->setGeometry(220, 20, 30, 30);

  textinfo->setGeometry(300, 40, 350, h - 50);
  
  b1->setGeometry(10,10,100,30);
  b2->setGeometry(110,10,100,30);
  b3->setGeometry(210,10,100,30);
  b4->setGeometry(10,40,100,30);
  b5->setGeometry(110,40,100,30);
  b6->setGeometry(210,40,100,30);
  b7->setGeometry(10,70,100,30);
  b9->setGeometry(210,70,100,30);

  int spalte=270;
  int zeile=35;
  int y=0;
  int y1=0;
  int j;
  
  for(int i=10; i<100; i++){
    if(y > y1)y1=y;
    if(i%10 == 0)y=0;
    j = ((i+20)/10)%3;
    //qDebug("i=%i j=%i",i,j);
    if(!dspparam[i]->isHidden()){
      ldspparam[i]->setGeometry(5+j*spalte, 20+zeile*y, 30, 30);
      dspparam[i]->setGeometry(40+j*spalte, 20+zeile*y, 55, 30);
      lparambeschr[i]->setGeometry(97+j*spalte, 20+zeile*y, 300, 30);
      y++;
    }
  }
  dsptabwidget->setGeometry(10,160,830,(y1)*35+50);
  
  gparam->setGeometry(320,10,110,90);
  rbgn->setGeometry(10,20,150,20);
  rbge->setGeometry(10,40,150,20);
  rbrt->setGeometry(10,60,150,20);

  gseitenband->setGeometry(440,10,90,70);
  rbusb->setGeometry(10,20,150,20);
  rblsb->setGeometry(10,40,150,20);
  
  gmode->setGeometry(440,80,90,70);
  rbssb->setGeometry(10,20,150,20);
  rbcw->setGeometry(10,40,150,20);

  gbefehlsid->setGeometry(540,10,70,70);
  rbuser->setGeometry(10,20,150,20);
  rbstar->setGeometry(10,40,150,20);
  
  buttonfileladen1->setGeometry(640, 10, 190, 30);
  buttonparamsave->setGeometry(640, 40, 190, 30);
  
  buttonxparamladen->setGeometry(640, 80, 190, 30);
  buttonxparamsave->setGeometry(640, 110, 190, 30);
  cbdmoni->setGeometry(640, 140, 190, 30);

  grxeq->setGeometry(160,10,120+31*18,370);
  for(int i=0; i<31; i++){
    slrx[i]->setGeometry(50+i*18,30,18,300);
    slrxlabel3[i]->setGeometry(50+i*18,20,25,10);
    slrxlabel4[i]->setGeometry(50+i*18,340,25,10);
  }
  slrxlabel3[31]->setGeometry(50+31*18,20,60,10);
  slrxlabel4[31]->setGeometry(50+31*18,340,60,10);
  for(int i=0; i<14; i++){
    slrxlabel1[i]->setGeometry(5,35+(i*(300/14)),40,20);
    slrxlabel2[i]->setGeometry(10+(50+31*18),35+(i*(300/14)),40,20);
  }
  buttonrxeqladen->setGeometry(20,40,130,30);
  buttonrxeqspeichern->setGeometry(20,70,130,30);
  buttonrxeq2pic->setGeometry(20,100,130,30);
  lrxstatus->setGeometry(20,130,130,30);
  
  gtxeq->setGeometry(160,10,120+31*18,370);
  for(int i=0; i<31; i++){
    sltx[i]->setGeometry(50+i*18,30,18,300);
    sltxlabel3[i]->setGeometry(50+i*18,20,25,10);
    sltxlabel4[i]->setGeometry(50+i*18,340,25,10);
  }
  sltxlabel3[31]->setGeometry(50+31*18,20,60,10);
  sltxlabel4[31]->setGeometry(50+31*18,340,60,10);
  for(int i=0; i<14; i++){
    sltxlabel1[i]->setGeometry(5,35+(i*(300/14)),40,20);
    sltxlabel2[i]->setGeometry(10+(50+31*18),35+(i*(300/14)),35,20);
  }
  buttontxeqladen->setGeometry(20,40,130,30);
  buttontxeqspeichern->setGeometry(20,70,130,30);
  buttontxeq2pic->setGeometry(20,100,130,30);
  ltxstatus->setGeometry(20,130,130,30);

  lpbagc->setGeometry(20,20,700,30);
  pbagc->setGeometry(20,50,700,10);
  stepinfo->setGeometry(120,70,600,200);
  buttonifstep->setGeometry(20,70,90,30);
  buttonifabbruch->setGeometry(20,110,90,30);
  
  lpbsmagc->setGeometry(20,20,700,30);
  pbsmagc->setGeometry(20,50,700,10);
  stepsminfo->setGeometry(120,70,600,150);
  buttonsmstep->setGeometry(20,70,90,30);
  buttonsmabbruch->setGeometry(20,110,90,30);

  grsm->setGeometry(20,230,700,250);
  for(int i=0; i<11; i++){
    lsm[i]->setGeometry(50+i*57, 30, 57, 30);
    slip3[i]->setGeometry(50+i*57, 60, 50, 30);
    slnf[i]->setGeometry(50+i*57, 100, 50, 30);
  }
  lsm[11]->setGeometry(10, 60, 50, 30);
  lsm[12]->setGeometry(10, 100, 50, 30);
  for(int i=0; i<4; i++){
    lsm[i+13]->setGeometry(50+i*57, 150, 50, 30);
    sldds[i]->setGeometry(50+i*57, 180, 50, 30);
  }
  lsm[17]->setGeometry(10, 180, 50, 30);
}

void starcat::setHWText(){
  star1Act->setText(einst.starpfad[0]);
  star2Act->setText(einst.starpfad[1]);
  star3Act->setText(einst.starpfad[2]);
}

void starcat::cfgladen(){
  configfile cfgk;

  cfgk.open(homedir.filePath("starcat.cfg"));
  #ifdef Q_WS_WIN
  einst.srs232 = cfgk.readString("rs232","COM1");
  #else
  einst.srs232 = cfgk.readString("rs232","/dev/ttyS0");
  #endif
  //qDebug()<<einst.srs232;
  einst.picrs232writetime = cfgk.readInteger("picrs232writetime", 10);
  einst.dsprs232writetime = cfgk.readInteger("dsprs232writetime", 2);
  einst.paramrs232writetime = cfgk.readInteger("paramrs232writetime", 0);

  einst.starpfad[0] = cfgk.readString("starpfad","Pfad von SW fuer HW1");
  einst.dspcodefilename[0] = cfgk.readString("dspcodefilename","STAR2b1x.xjp");
  einst.filterfilename[0] = cfgk.readString("filterfilename","filters.xjp");
  einst.rxeqfilename[0] = cfgk.readString("rxeqfilename","RxEQ.dat");
  einst.txeqfilename[0] = cfgk.readString("txeqfilename","TxEQ.dat");
  einst.ad603filename[0] = cfgk.readString("ad603filename","AD603.dat");
  einst.parameterfilename[0] = cfgk.readString("parameterfilename","user2b2.xjp");
  einst.xparameterfilename[0] = cfgk.readString("xparameterfilename","Xparams.xjp");
  einst.standardparameterfilename[0] = cfgk.readString("standardparameterfilename","standard.xjp");
  einst.scalfilename[0] = cfgk.readString("scalfilename","scal.dat");
  einst.testfilename[0] = cfgk.readString("testfilename","Test05.xjp");
  
  einst.starpfad[1] = cfgk.readString("starpfad1","Pfad von SW fuer HW2");
  star2Act->setText(einst.starpfad[1]);
  einst.dspcodefilename[1] = cfgk.readString("dspcodefilename1","STAR2b1x.xjp");
  einst.filterfilename[1] = cfgk.readString("filterfilename1","filters.xjp");
  einst.rxeqfilename[1] = cfgk.readString("rxeqfilename1","RxEQ.dat");
  einst.txeqfilename[1] = cfgk.readString("txeqfilename1","TxEQ.dat");
  einst.ad603filename[1] = cfgk.readString("ad603filename1","AD603.dat");
  einst.parameterfilename[1] = cfgk.readString("parameterfilename1","user2b2.xjp");
  einst.xparameterfilename[1] = cfgk.readString("xparameterfilename1","Xparams.xjp");
  einst.standardparameterfilename[1] = cfgk.readString("standardparameterfilename1","standard.xjp");
  einst.scalfilename[1] = cfgk.readString("scalfilename1","scal.dat");
  einst.testfilename[1] = cfgk.readString("testfilename","Test05.xjp");
  
  einst.starpfad[2] = cfgk.readString("starpfad2","Pfad von SW fuer HW3");
  star3Act->setText(einst.starpfad[2]);
  einst.dspcodefilename[2] = cfgk.readString("dspcodefilename2","STAR2b1x.xjp");
  einst.filterfilename[2] = cfgk.readString("filterfilename2","filters.xjp");
  einst.rxeqfilename[2] = cfgk.readString("rxeqfilename2","RxEQ.dat");
  einst.txeqfilename[2] = cfgk.readString("txeqfilename2","TxEQ.dat");
  einst.ad603filename[2] = cfgk.readString("ad603filename2","AD603.dat");
  einst.parameterfilename[2] = cfgk.readString("parameterfilename2","user2b2.xjp");
  einst.xparameterfilename[2] = cfgk.readString("xparameterfilename2","Xparams.xjp");
  einst.standardparameterfilename[2] = cfgk.readString("standardparameterfilename2","standard.xjp");
  einst.scalfilename[2] = cfgk.readString("scalfilename2","scal.dat");
  einst.testfilename[2] = cfgk.readString("testfilename","Test05.xjp");
  
  starnr = cfgk.readInteger("starnr",0);
  
  cfgk.close();
  picmodem->closetty();
  rs232isopen = picmodem->opentty(einst.srs232);
  if(!rs232isopen){
    QMessageBox::about(this, tr("RS232 readSettings()"),tr("Die RS232 ist nicht offen!"));
  }else{
    buttondspbefehl->setEnabled(TRUE);
  }
  switch(starnr){
    case 0:
            star1Act->setChecked(TRUE);
            star2Act->setChecked(FALSE);
            star3Act->setChecked(FALSE);
            break; 
    case 1:
            star1Act->setChecked(FALSE);
            star2Act->setChecked(TRUE);
            star3Act->setChecked(FALSE);
            break; 
    case 2:
            star1Act->setChecked(FALSE);
            star2Act->setChecked(FALSE);
            star3Act->setChecked(TRUE);
            break;
    /*
    default:
            star1Act->setChecked(TRUE);
            star2Act->setChecked(FALSE);
            star3Act->setChecked(FALSE);
            break;
            */ 
  }
  setHWText();
}

void starcat::cfgspeichern(){
  configfile cfgk;

  cfgk.open(homedir.filePath("starcat.cfg"));
  cfgk.writeString("starpfad",einst.starpfad[0]);
  cfgk.writeString("dspcodefilename",einst.dspcodefilename[0]);
  cfgk.writeString("filterfilename",einst.filterfilename[0]);
  cfgk.writeString("rxeqfilename",einst.rxeqfilename[0]);
  cfgk.writeString("txeqfilename",einst.txeqfilename[0]);
  cfgk.writeString("ad603filename",einst.ad603filename[0]);
  cfgk.writeString("parameterfilename",einst.parameterfilename[0]);
  cfgk.writeString("xparameterfilename",einst.xparameterfilename[0]);
  cfgk.writeString("standardparameterfilename",einst.standardparameterfilename[0]);
  cfgk.writeString("scalfilename",einst.scalfilename[0]);
  cfgk.writeString("testfilename",einst.testfilename[0]);
  cfgk.writeString("starpfad1",einst.starpfad[1]);
  cfgk.writeString("dspcodefilename1",einst.dspcodefilename[1]);
  cfgk.writeString("filterfilename1",einst.filterfilename[1]);
  cfgk.writeString("rxeqfilename1",einst.rxeqfilename[1]);
  cfgk.writeString("txeqfilename1",einst.txeqfilename[1]);
  cfgk.writeString("ad603filename1",einst.ad603filename[1]);
  cfgk.writeString("parameterfilename1",einst.parameterfilename[1]);
  cfgk.writeString("xparameterfilename1",einst.xparameterfilename[1]);
  cfgk.writeString("standardparameterfilename1",einst.standardparameterfilename[1]);
  cfgk.writeString("scalfilename1",einst.scalfilename[1]);
  cfgk.writeString("testfilename",einst.testfilename[1]);
  cfgk.writeString("starpfad2",einst.starpfad[2]);
  cfgk.writeString("dspcodefilename2",einst.dspcodefilename[2]);
  cfgk.writeString("filterfilename2",einst.filterfilename[2]);
  cfgk.writeString("rxeqfilename2",einst.rxeqfilename[2]);
  cfgk.writeString("txeqfilename2",einst.txeqfilename[2]);
  cfgk.writeString("ad603filename2",einst.ad603filename[2]);
  cfgk.writeString("parameterfilename2",einst.parameterfilename[2]);
  cfgk.writeString("xparameterfilename2",einst.xparameterfilename[2]);
  cfgk.writeString("standardparameterfilename2",einst.standardparameterfilename[2]);
  cfgk.writeString("scalfilename2",einst.scalfilename[2]);
  cfgk.writeString("testfilename",einst.testfilename[2]);
  cfgk.writeString("rs232",einst.srs232);
  cfgk.writeInteger("picrs232writetime", einst.picrs232writetime);
  cfgk.writeInteger("dsprs232writetime", einst.dsprs232writetime);
  cfgk.writeInteger("paramrs232writetime", einst.paramrs232writetime);
  cfgk.writeInteger("starnr", starnr);
  cfgk.close();
}

void starcat::clickparamladen(){
  textinfo->append("---------------------------------");
  bsmparam = FALSE;
  bxparam = FALSE;
  readparameter(einst.parameterfilename[starnr]);
  bparamgeaendert = FALSE;
}

void starcat::clickfileladen(){
  QFile f;
  bool dateiende = FALSE;
  int zeilennr;
  QString qs;
  
  //qDebug("starcat::clickfileladen()");
  f.setFileName(einst.dspcodefilename[starnr]);
  if(f.open(QIODevice::ReadOnly)){
    //textinfo->clear();
    QTextStream ts(&f);
    //erste Zeile lesen diese Zeile hat keine Bedeutung
    zeile = ts.readLine();
    zeilennr = 0;
    listdspcode.clear(); //liste loeschen
    do{
      zeile = ts.readLine();
      zeilennr++;
      if(zeile.contains(27)){
        dateiende = TRUE;
      }
      if(!dateiende){
        listdspcode.append(zeile);
        //qDebug(qPrintable(zeile));
      }
    }while(!ts.atEnd() and !dateiende);
    qs.sprintf("%i",listdspcode.count()+1);
    qs = tr("DSP File ") + qs + tr(" Zeilen geladen");
    textinfo->append(qs);
    f.close();
  }else{
    qs = tr("Datei \"") + einst.dspcodefilename[starnr] + tr("\" nicht gefunden!");
    QMessageBox::critical(this, tr("Datei nicht gefunden!"),qs);
    bdateifehler = TRUE;
    textinfo->append(qs);
    return;
  }
  f.setFileName(einst.filterfilename[starnr]);
  if(f.open(QIODevice::ReadOnly)){
    QTextStream ts(&f);
    //erste Zeile lesen diese Zeile hat keine Bedeutung
    zeilennr = 0;
    listfilter.clear(); //liste loeschen
    do{
      zeile = ts.readLine();
      textinfo->append(zeile);
      zeilennr++;
      listfilter.append(zeile);
    }while(!ts.atEnd());
    qs.sprintf("%i",zeilennr);
    qs = tr("Filter-File ") + qs + tr(" Zeilen geladen");

    //qs.sprintf("Filter-File %i Zeilen geladen",zeilennr);

    textinfo->append(qs);
    f.close();
  }else{
    qs = tr("Datei \"") +einst.filterfilename[starnr] + tr("\" nicht gefunden!");
    QMessageBox::critical(this, tr("Datei nicht gefunden!"),qs);
    bdateifehler = TRUE;
    textinfo->append(qs);
    return;
  }
  checksum = 0;
  buffer.clear();
  dsplist2buffer();
  filterlist2buffer();
  loadchecksumme();
  bsmparam = FALSE;
  bxparam = FALSE;
  readparameter(einst.parameterfilename[starnr]);
  bparamgeaendert = FALSE;
}

void starcat::clickxparamladen(){
  bxparam = TRUE;
  readparameter(einst.xparameterfilename[starnr]);
  if(!bdateifehler){
    bparamgeaendert = FALSE;
  }
}

void starcat::clicktestladen(){
  QString besch =tr(
  "<b>Die Testsoftware wird direkt in den DSP PicAStar geladen.</b><br>"
  "<br>"
  "1. Verbindung <b>\"RS232-DSP\"</b> und \"RS232-PC\" herstellen.<br>"
  "2. Nach \"POWER ON\" beim Hochlauf die <b>\"Taste 0\"</b> druecken<br>"
  "3. Die PIC-Firmware startet sofort.<br>"
  "4. Die DSP-LED blinkt und der DSP kann geladen werden.<br>"
  "5. \"OK\" am PC druecken.<br>"
  "<br>"
  "Nachdem die Software geladen ist, ist die Sprache vom Mikrofon <br>"
  "in einem der beiden Ausgabekanaele des DSPs zu hoeren. Damit <br>"
  "kann der digitale Weg der NF getestet werden.");
  ;
  if(QMessageBox::Ok == QMessageBox::information(this,
                                                 tr("Laden DSP-Test-FW direkt"),
                                                 besch, QMessageBox::Ok | QMessageBox::Cancel)){
    QFile f;
    bool dateiende = FALSE;
    int zeilennr;
    QString qs;
    
    textinfo->append("---------------------------------");
    f.setFileName(einst.testfilename[starnr]);
    if(f.open(QIODevice::ReadOnly)){
      //textinfo->clear();
      QTextStream ts(&f);
      //erste Zeile lesen diese Zeile hat keine Bedeutung
      zeile = ts.readLine();
      zeilennr = 0;
      listdspcode.clear(); //liste loeschen
      do{
        zeile = ts.readLine();
        zeilennr++;
        if(zeile.contains(27)){
          dateiende = TRUE;
        }
        if(!dateiende){
          listdspcode.append(zeile);
          //qDebug(qPrintable(zeile));
        }
      }while(!ts.atEnd() and !dateiende);

      qs.sprintf("%i",listdspcode.count()+1);
      qs = tr("DSP File ") + qs + tr(" Zeilen geladen");


      //qs.sprintf("DSP File %i Zeilen geladen",listdspcode.count()+1);
      textinfo->append(qs);
      f.close();
    }else{
      qs = tr("Datei \"") + einst.testfilename[starnr] + tr("\" nicht gefunden!");
      QMessageBox::critical(this, tr("Datei nicht gefunden!"),qs);
      bdateifehler = TRUE;
      textinfo->append(qs);
      return;
    }
    checksum = 0;
    buffer.clear();
    dsplist2buffer();
    loadchecksumme();
    buffer2dsp();
    textinfo->append(tr("buffer2dsp() Fertig!"));
  }
}

void starcat::clickdspladen(){
  QString besch = tr(
  "<b>Die DSP-FW+Parameter werden direkt in den DSP PicAStar geladen.</b><br>"
  "Die Daten werden fuer den DSP benoetigt!<br>"
  "<b>Diese Funktion kann fuer den PicAStar nach <br>"
  "G3XJP und DL4JAL verwendet werden!</b><br>"
  "<br>"
  "1. Verbindung <b>\"RS232-DSP\"</b> und \"RS232-PC\" herstellen.<br>"
  "2. PicAStar ausschalten<br>"
  "3. Nach \"POWER ON\" beim Hochlauf die <b>\"Taste 0\"</b> druecken<br>"
  "4. Die PIC-Firmware startet sofort.<br>"
  "5. Die DSP-LED blinkt und der DSP kann geladen werden.<br>"
  "6. \"OK\" am PC druecken.<br>"
  "<br>"
  "Nach dem Laden meldet sich der DSP-Baustein mit einem \"HI\"<br>"
  "aus dem Lautsprecher (in CW)");
  ;
  if(bxparamgeaendert){
    QMessageBox::information(this, tr("X-PARAMETER"), tr("<b>Die X-Parameter wurden geaendert!</b><br>"
                                   "Zuerst die X-Parameter SPEICHERN und alle Daten neu einlesen!"));
    dspbufferloeschen();
    return;
  }
  // alle 0-9 Parameter aus
  b1->setChecked(FALSE);
  b2->setChecked(FALSE);
  b3->setChecked(FALSE);
  b4->setChecked(FALSE);
  b5->setChecked(FALSE);
  b6->setChecked(FALSE);
  b7->setChecked(FALSE);
  b9->setChecked(FALSE);
  // SSB gruen LSB
  rbgn->setChecked(TRUE);
  rbssb->setChecked(TRUE);
  rblsb->setChecked(TRUE);
  parametersetzen();  //richtig grafisch darstellen
  if(QMessageBox::Ok == QMessageBox::information(this,
                                                 tr("Laden DSP-FW direkt"),
                                                 besch, QMessageBox::Ok | QMessageBox::Cancel)){
    textinfo->append("---------------------------------");
    clickfileladen();
    buffer2dsp();
    textinfo->append(tr("buffer2dsp() Fertig!"));
    parameter2dsp();
    textinfo->append(tr("parameter2dsp() Fertig!"));
  }
}

void starcat::clickpicladen(){
  QString besch = tr(
  "<b>Die DSP-FW+Parameter werden in den externen Eeprom des PnM geladen.</b><br>"
  "Die Daten werden fuer den Warmstart bei POWER ON benoetigt!<br>"
  "<b>Diese Funktion kann fuer den PicAStar nach <br>"
  "G3XJP und DL4JAL verwendet werden!</b><br>"
  "<br>"
  "1. Verbindung <b>\"RS232-PnM\"</b> und \"RS232-PC\" herstellen.<br>"
  "2. PicAStar ausschalten<br>"
  "3. Nach \"POWER ON\" beim Hochlauf die <b>\"Taste #\"</b> druecken<br>"
  "4. Die LED-Anzeige erlischt.<br>"
  "5. Anschliessend am PC in diesem Dialog \"OK\" druecken<br>"
  "6. Das Laden der Firmware+Parameter in den ext. Eeprom beginnt!<br>"
  "<br>"
  "Die Daten werden in den externen Eeprom der PnM-Baugruppe geladen und<br>"
  "sofort wieder als Kontrolle gelesen und verglichen.<br>"
  "Tritt ein Fehler auf wird das Laden sofort abgebrochen!!");

  //qDebug("starcat::clickpicladen()");
  if(bxparamgeaendert){
    QMessageBox::information(this, tr("X-PARAMETER"), tr("<b>Die X-Parameter wurden geaendert!</b><br>"
                                   "Zuerst die X-Parameter SPEICHERN und alle Daten neu einlesen!"));
    return;
  }
  if(QMessageBox::Ok == QMessageBox::information(this,
                                                 tr("Laden DSP-FW in PIC ext. Eeprom"),
                                                 besch, QMessageBox::Ok | QMessageBox::Cancel)){
    textinfo->append("---------------------------------");
    clickfileladen();
    buffer2pic_alt();
    textinfo->append(tr("buffer2pic_alt() Fertig!"));
    parameter2pic_alt();
    textinfo->append(tr("parameter2pic_alt() Fertig!"));
  }
}

void starcat::clickpar2pic(){
  QString besch = tr(
  "<b>Die DSP-Parameter werden in den externen Eeprom der PnM-Baugruppe geladen.</b><br>"
  "Die Parameter-Daten werden fuer die DSP-Firmware benoetigt!<br>"
  "<b>Diese Funktion kann fuer den PicAStar nach <br>"
  "G3XJP und DL4JAL verwendet werden!</b><br>"
  "<br>"
  "1. Die DSP-Firmware muss laufen. Ist das der Fall<br>"
  "2. Verbindung  <b>\"RS232-PnM\"</b> und \"RS232-PC\" herstellen.<br>"
  "3. DDS-Kommando \"999\" eingeben. Warmstart des PIC erfolgt<br>"
  "4. Sofort nach \"Warmstart\" die <b>\"Taste 1\"</b> druecken<br>"
  "4. Die LED-Anzeige erlischt.<br>"
  "6. Anschliessend am PC in diesem Dialog \"OK\" druecken<br>"
  "7. Das Laden der Parameter in den ext. Eeprom beginnt!<br>"
  "<br>"
  "Die Daten werden in den externen Eeprom der PIC-Baugruppe geladen.")
  ;
  
  if(QMessageBox::Ok == QMessageBox::information(this,
                                                 tr("Laden Parameter in PIC ext. Eeprom"),
                                                 besch, QMessageBox::Ok | QMessageBox::Cancel)){
    textinfo->append("---------------------------------");
    clickfileladen();
    parameter2pic_alt();
    textinfo->append(tr("parameter2pic_alt() Fertig!"));
  }
}

void starcat::dsplist2buffer(){
  QString zeile;
  QString ds;
  QString qs;
  uchar ad1;
  uchar ad2;
  int index, xa;
  bool ok;
  bool Lspa;
  bool divert;
  
  //qDebug("starcat::dsplist2buffer()");
  index = 0;
  xa = 0;
  while(index < listdspcode.count()){
    buf.clear();
    zeile = listdspcode.at(index);
    zeile.remove(QChar(' '));
    index++;
    //qDebug(qPrintable(zeile));
    Lspa = zeile.contains("@PA");
    if(Lspa){
      ds = "$DP";
    }else{
      ds = "$DD";
    }
    zeile = listdspcode.at(index);
    zeile.remove(QChar(' '));
    index++;
    qs = zeile.left(2);
    //textinfo->append(qs);
    ad1 = qs.toInt(&ok,16);
    qs = zeile.right(2);
    //textinfo->append(qs);
    ad2 = qs.toInt(&ok,16);
    divert = (ds == "$DP") and (ad1 == 0) and (ad2 == 0);
    do{
      zeile = listdspcode.at(index);
      zeile.remove(QChar(' '));
      //qDebug(qPrintable(zeile));
      index++;
      //ckb = 0;
      if(!zeile.contains("#")){
        qs = zeile.left(2);
        //qDebug(qPrintable(qs));
        cka = qs.toInt(&ok,16);
        buf.append(cka);
        if(!Lspa){
          qs = zeile.mid(2,2);
          ckc = qs.toInt(&ok,16);
          buf.append(ckc);
          updatechecksumme();
        }else{
          qs = zeile.mid(2,2);
          //qDebug(qPrintable(qs));
          ckb = qs.toInt(&ok,16);
          buf.append(ckb);
          qs = zeile.mid(4,2);
          //qDebug(qPrintable(qs));
          ckc = qs.toInt(&ok,16);
          buf.append(ckc);
          updatechecksumme();
        }
      }
      xa++;
    }while(!zeile.contains("#"));//Ende eines Bolckes
    xa--;
    if(divert){
      buffer.append('$');
      buffer.append('D');
      buffer.append('P');
      buffer.append(0x3f);
      buffer.append(0xc0);
      buffer.append(0x00);
      buffer.append(0x30);
      for(int i=0; i < 48*3; i++){
        buffer.append(buf.at(i));
      }
      buffer.append(0x0d);
      //buffer.append(0x0a);
      xa = xa - 48;
      buffer.append('$');
      buffer.append('D');
      buffer.append('P');
      buffer.append(0);
      buffer.append(48);
      uchar y = xa / 256;
      uchar z = xa % 256;
      buffer.append(y);
      buffer.append(z);
      for(int i=48*3; i < buf.count(); i++){
        buffer.append(buf.at(i));
      }
      buffer.append(0x0d);
      //buffer.append(0x0a);
    }else{
      for(int i=0; i<3; i++){
        buffer.append(ds.at(i).cell());
      }
      buffer.append(ad1);
      buffer.append(ad2);
      uchar y = xa / 256;
      uchar z = xa % 256;
      buffer.append(y);
      buffer.append(z);
      for(int i=0; i < buf.count(); i++){
        buffer.append(buf.at(i));
      }
      buffer.append(0x0d);
      //buffer.append(0x0a);
    }
    xa=0;
  }
  //qs.sprintf(" %i Char im buffer", buffer.count());
  qs.sprintf("%i", buffer.count());
  qs = qs + tr(" Char im buffer");
  textinfo->append(qs);
}

void starcat::filterlist2buffer(){
  QString zeile;
  QString ds;
  QString qs;
  QString saddr;
  QString dateiname;
  uchar ad1;
  uchar ad2;
  int index, pos1=0, pos2=0, zeilennr;
  bool ok;
  QFile f;
  
  //qDebug("starcat::filterlist2buffer()");
  index = 0;
  QDir filterpfad;
  filterpfad.setPath(einst.starpfad[starnr]);
  filterpfad.cd("Filters");
  while(index<listfilter.count()){
    zeile = listfilter.at(index);
    index++;
    pos1 = zeile.indexOf(",",0);
    pos2 = zeile.indexOf(",",pos1+1);
    dateiname = zeile.left(pos1-1);
    dateiname.remove(QChar(' '));
    dateiname = filterpfad.filePath(dateiname);
    textinfo->append(dateiname);
    f.setFileName(dateiname);
    if(f.open(QIODevice::ReadOnly)){
      QTextStream ts(&f);
      qs = zeile.mid(pos2+1, zeile.length());
      qs.remove(QChar(' '));
      textinfo->append(qs);
      saddr = qs.left(2);
      ad1 = saddr.toInt(&ok,16);
      saddr = qs.right(2);
      ad2 = saddr.toInt(&ok,16);
      buffer.append('$');
      buffer.append('D');
      buffer.append('P');
      buffer.append(ad1);
      buffer.append(ad2);
      zeilennr = 0;
      buf.clear();
      while(!ts.atEnd()){
        ts >> zeile;
        zeilennr++;
        zeile.remove(QChar(' '));
        //qDebug(qPrintable(zeile));
        if(zeile.length() < 6)break;
        saddr = zeile.left(2);
        //qDebug(qPrintable(saddr));
        cka = saddr.toInt(&ok,16);
        //qDebug("%u",cka);
        saddr = zeile.mid(2,2);
        ckb = saddr.toInt(&ok,16);
        //qDebug("%u",ckb);
        saddr = zeile.mid(4,2);
        ckc = saddr.toInt(&ok,16);
        //qDebug("%u",ckc);
        buf.append(cka);
        buf.append(ckb);
        buf.append(ckc);
        updatechecksumme();
      }
      zeilennr--;
      buffer.append(0);
      buffer.append(uchar(zeilennr));
      for(int i=0; i< buf.count(); i++){
        buffer.append(buf.at(i));
      }
      buffer.append(0x0d);
      //buffer.append(0x0a);
      //qs.sprintf("File %i Zeilen geladen",zeilennr);
      qs.sprintf("%i",zeilennr);
      qs = tr("File ") + qs + tr(" Zeilen geladen");
      textinfo->append(qs);
      f.close();
    }else{
      qs = tr("Datei \"") + dateiname + tr("\" aus der Filterdatei nicht gefunden!");
      QMessageBox::critical(this, tr("Datei nicht gefunden!"),qs);
      bdateifehler = TRUE;
      textinfo->append(qs);
      return;
    }
    //qs.sprintf(" %i Char im buffer", buffer.count());
    qs.sprintf(" %i", buffer.count());
    qs = qs + tr(" Char im buffer");
    textinfo->append(qs);
  }
}

void starcat::DSPcommando(uchar nr, uchar value){
  if(rs232isopen){
    paramchar2rs232('~');
    paramchar2rs232(nr);
    paramchar2rs232(value);
    //qDebug("DSPbef %i DSPwert %i", nr, value);
  }
}

void starcat::updatechecksumme(){

  checksum += (256*cka);
  while(checksum > 32767)checksum -= 32768;
  checksum += ckb;
  while(checksum > 32767) checksum -= 32768;
  checksum += ckc;
  while(checksum > 32767) checksum -= 32768;
}

void starcat::loadchecksumme(){
  QString qs;
  
  //qDebug("starcat::loadchecksumme()");
  buffer.append('$');
  buffer.append('D');
  buffer.append('P');
  buffer.append(0x37);
  buffer.append(0xFE);
  buffer.append(0x00);
  buffer.append(0x01);
  buffer.append(uchar(checksum / 256));
  buffer.append(uchar(checksum % 256));
  buffer.append(0);
  buffer.append(0x0d);
  //qs.sprintf("Checksumme %i",checksum);
  qs.sprintf("%i",checksum);
  qs = tr("Checksumme ") + qs;
  textinfo->append(qs);
}

void starcat::buffer2dsp(){
  //uchar b;
  QChar c;
  QChar c1;
  QFile f;

  QProgressDialog prd(tr("DSP-FW Laden"), tr("Abbrechen"), 0, buffer.count(), this);
  prd.show();
  //qDebug("starcat::bufferToRs232()");
  //f.setFileName("dsptest");
  //if(f.open(QIODevice::WriteOnly)){
  if(rs232isopen){
    while(defaultlesenrtty());
    //QTest::qWait(1000);
    DSPcommando(111,0);
    delay(200);
    dspchar2rs232('$');
    dspchar2rs232('$');
    dspchar2rs232('$');
    dspchar2rs232(uchar(0x0d));
    //QDataStream ds(&f);
    delay(200);
    for(int i=0; i < buffer.count(); i++){
      prd.setValue(i);
      if(prd.wasCanceled())return;
      if(i < (buffer.count()-2)){
        if((buffer.at(i) == '$') and (buffer.at(i+1) == 'D') and (buffer.at(i+2) == 'P')){
          delay(200);
        }
      }
      dspchar2rs232(buffer.at(i));
      //ds << buffer.at(i);
      qApp->processEvents();//Austritt aus der Funktion fuer Events
    }
  }
  //delay(500);
  //f.close();
  dspchar2rs232('#');
  dspchar2rs232('#');
  dspchar2rs232('#');
  dspchar2rs232(uchar(0x0d));
  delay(200);
  QString qs;
  dspchar2rs232('$');
  dspchar2rs232('G');
  dspchar2rs232('O');
  dspchar2rs232(uchar(0));
  dspchar2rs232(uchar(0));
  dspchar2rs232(uchar(0x0d));
  delay(200);
  //}
  prd.setValue(buffer.count());
}
/*
void starcat::buffer2pic_neu(){
  //uchar b;
  uchar c;
  uchar c1;
  QFile f,f1;
  int id;
  int re;
  
  bool abbruch = FALSE;
  
  QProgressDialog prd("DSP-FW in PIC Laden", "Abbrechen", 0, buffer.count(), this);
  prd.show();
  //qDebug("starcat::buffer2pic_neu()");
  //Kontrolldateien mit Echodatei
  f.setFileName("dsp2pic.dat");
  f1.setFileName("dsp2pic_echo.dat");
  if(f.open(QIODevice::WriteOnly) and f1.open(QIODevice::WriteOnly)){
    if(rs232isopen){
      defaultlesenrtty();//Der RS232 RX Buffer muss geleert werden
      //Kontrolldateien mit Echodatei
      QDataStream ds(&f);
      QDataStream ds1(&f1);
      id = 0;
      do{
        prd.setValue(id);
        if(prd.wasCanceled())return;
        c1 = buffer.at(id); // Byte aus Buffer holen
        picmodem->writeChar(c1); //und in die RS232 TX geben
        id++; // Index um ein Zeichen weiter
        if(id == buffer.count())abbruch=TRUE; //Bufferende erreicht ABBRUCH
        if(abbruch)break; //ABBRUCH
        re = 0; //RS232 RX gelesen Zeichen = 0
        while(re != 1){ // Zeichen lesen
          re = picmodem->readttybuffer(&c,1);
          qApp->processEvents();//Austritt aus der Funktion fuer Events
        };
        //Zeichen und Echo in Kontrolldateien schreiben
        ds << c1;
        ds1 << c;
        // Sind Bytes nicht gleich FEHLER und ABBRUCH
        if(c1 != c){
          QString qs;
          qs.sprintf("Adresse:%04X File:%X Pic:%X",id-1,c1,c);
          QMessageBox::about(this, tr("Error!"),qs);
          f.close();
          f1.close();
          return;
        }
      }while(!abbruch);
      prd.setValue(buffer.count());
    }
    //Kontrolldateien schliessen
    f.close();
    f1.close();
  }
}
*/
void starcat::buffer2pic_alt(){
  //uchar b;
  uchar c;
  uchar c1;
  int id;
  int re;
  
  bool abbruch = FALSE;
  
  //qDebug("starcat::buffer2pic_alt()");
  QProgressDialog prd(tr("DSP-FW in PIC Laden"), tr("Abbrechen"), 0, buffer.count(), this);
  prd.show();
  if(rs232isopen){
    while(defaultlesenrtty());//Der RS232 RX Buffer muss geleert werden
    int j=0;
    while(j<7){
      picchar2rs232('#');
      re = 0; //RS232 RX gelesen Zeichen = 0
      while(re != 1){ // Zeichen lesen
        re = picmodem->readttybuffer(&c,1);
        qApp->processEvents();//Austritt aus der Funktion fuer Events
        if(prd.wasCanceled ())return;
      };
      if(c == '#'){
        j++;
      }else{
        j=0;
      }
    }
    picchar2rs232('x');
    re = 0; //RS232 RX gelesen Zeichen = 0
    while(re != 1){ // Zeichen lesen
      re = picmodem->readttybuffer(&c,1);
      qApp->processEvents();//Austritt aus der Funktion fuer Events
        if(prd.wasCanceled ())return;
    };
    if(c != 'x'){
      QString qs;
      //qs.sprintf("Keine Syncronisation!!!<br>\"x\" an PIC gesendet<br>\"%c\" vom PIC empfangen.",c);
      qs.sprintf("%c",c);
      qs = tr("Keine Syncronisation!!!<br>\"x\" an PIC gesendet<br>\"") + qs + tr("\" vom PIC empfangen.");
      QMessageBox::about(this, tr("Error!"),qs);
      return;
    }
    id = 0;
    do{
      prd.setValue(id);
      if(prd.wasCanceled())return;
      c1 = buffer.at(id); // Byte aus Buffer holen
      picchar2rs232(c1); //und in die RS232 TX geben
      id++; // Index um ein Zeichen weiter
      if(id == buffer.count())abbruch=TRUE; //Bufferende erreicht ABBRUCH
      re = 0; //RS232 RX gelesen Zeichen = 0
      while(re != 1){ // Zeichen lesen
        re = picmodem->readttybuffer(&c,1);
        qApp->processEvents();//Austritt aus der Funktion fuer Events
        if(prd.wasCanceled ())return;
      };
      if(c1 != c){
        QString qs,qs1,qs2;

        //qs.sprintf("Adresse %04x File:%x Pic:%x",id-1,c1,c);
        qs.sprintf("%04x",id-1);
        qs.sprintf("%x",c1);
        qs.sprintf("%x",c);
        qs = tr("Adresse ") + qs + tr(" File:") + qs1 + tr(" Pic:") + qs2;
        QMessageBox::about(this, tr("Error!"),qs);
        return;
      }
    }while(!abbruch);
    prd.setValue(buffer.count());
  }
}

void starcat::readparameter(const QString pfname){
  QFile f;
  bool dateiende = FALSE;
  int zeilennr;
  QString qs;
  QString qs1;
  QString qs2;
  bool ok;
  
  f.setFileName(pfname);
  //qDebug("starcat::readparameter()");
  if(f.open(QIODevice::ReadOnly)){
    QTextStream ts(&f);
    //Kopfzeilen lesen
    paramkopf1 = ts.readLine();
    paramkopf2 = ts.readLine();
    zeilennr = 0;
    listparameter.clear(); //liste mit Parametern als String loeschen
    // alle Parameter einlesen
    do{
      zeile = ts.readLine();
      zeilennr++;
      if(zeile.contains("END FILE")){
        dateiende = TRUE;
      }
      if(!dateiende){
        listparameter.append(zeile);
        //qDebug(qPrintable(zeile));
      }
    }while(!ts.atEnd() and !dateiende);
    //qs.sprintf("Parameter File %i Zeilen geladen",listparameter.count()+1);
    qs.sprintf("%i",listparameter.count()+1);
    qs = tr("Parameter File ") + qs + tr(" Zeilen geladen");
    textinfo->append(qs);
    if(bsmparam)stepsminfo->append(qs);
    f.close();
  }else{
    qs = tr("Datei \"") + pfname + tr("\" nicht gefunden!");
    QMessageBox::critical(this, tr("Datei nicht gefunden!"),qs);
    textinfo->append(qs);
    if(bsmparam)stepsminfo->append(qs);
    bdateifehler=TRUE;
    return;
  }
  //alle Parameter in Zahlen wandeln
  for(int i=0;i<listparameter.count();i++){
    // Zeile lesen
    qs = listparameter.at(i);
    // Index ermitteln
    qs1 = qs.section(',',2,2);
    qs1.remove(QChar(' '));
    paramid = qs1.toInt(&ok);
    // Bezeichnung
    qs1 = qs.section(',',0,0);
    pbez[paramid] = qs1;
    // Befehlesnummern im Star
    qs1 = qs.section(',',1,1);
    qs1.remove(QChar(' '));
    puserid[paramid] = qs1.toInt(&ok);
    // ssbgruen
    qs1 = qs.section(',',3,3);
    qs1.remove(QChar(' '));
    pssbgn[paramid] = qs1.toInt(&ok);
    //qDebug("paramid %i pssbgn %i",paramid,pssbgn[paramid]);
    // ssbgelb
    qs1 = qs.section(',',4,4);
    qs1.remove(QChar(' '));
    pssbge[paramid] = qs1.toInt(&ok);
    // ssbrot
    qs1 = qs.section(',',5,5);
    qs1.remove(QChar(' '));
    pssbrt[paramid] = qs1.toInt(&ok);
    // cw gruen
    qs1 = qs.section(',',6,6);
    qs1.remove(QChar(' '));
    pcwgn[paramid] = qs1.toInt(&ok);
    // cw gelb
    qs1 = qs.section(',',7,7);
    qs1.remove(QChar(' '));
    pcwge[paramid] = qs1.toInt(&ok);
    // cw rot
    qs1 = qs.section(',',8,8);
    qs1.remove(QChar(' '));
    pcwrt[paramid] = qs1.toInt(&ok);
    // Minimum
    qs1 = qs.section(',',9,9);
    qs1.remove(QChar(' '));
    pmin[paramid] = qs1.toInt(&ok);
    // Maximum
    qs1 = qs.section(',',10,10);
    qs1.remove(QChar(' '));
    pmax[paramid] = qs1.toInt(&ok);
    // Faktor des Parameters
    qs1 = qs.section(',',11,11);
    qs1.remove(QChar(' '));
    pfaktor[paramid] = qs1.toDouble(&ok);
    // Page ist fuer mich ohne Bedeutung
    qs1 = qs.section(',',12,12);
    qs1.remove(QChar(' '));
    ppage[paramid] = qs1.toInt(&ok);
    //qDebug("parampage %i",ppage[paramid]);
    pxparam[paramid] = bxparam;
  }
  if(!bdateifehler){
    // Umschalten auf Starbefehlsnummerierung
    setuserid();
    rbuser->setChecked(TRUE);
    rbgn->setChecked(TRUE);
    rbssb->setChecked(TRUE);
    rblsb->setChecked(TRUE);
    param_geladen = TRUE;
    //gdspg3xjp->setEnabled(TRUE);
    //gdspdl4jal->setEnabled(TRUE);
    paramSetEnabled(TRUE); 
    parametersetzen();
  }
}

void starcat::readscalparam(){
  QFile f;
  int zeilennr;
  QString qs;
  bool ok;
  int wert;
  
  f.setFileName(einst.scalfilename[starnr]);
  //qDebug("starcat::readparameter()");
  if(f.open(QIODevice::ReadOnly)){
    QTextStream ts(&f);
    zeilennr = 0;
    listparameter.clear(); //liste mit Parametern als String loeschen
    // alle Parameter einlesen
    while(!ts.atEnd()){
      zeile = ts.readLine();
      zeilennr++;
      listparameter.append(zeile);
      //qDebug(qPrintable(zeile));
    }
    qs.sprintf("%i",listparameter.count());
    stepsminfo->append(tr("Scall-File ") + qs + tr(" Zeilen geladen"));
    f.close();
    sm_geladen = TRUE;
  }else{  
    qs = tr("Datei \"") + einst.scalfilename[starnr] + tr("\" nicht gefunden!");
    QMessageBox::critical(this, tr("Datei nicht gefunden!"),qs);
    stepsminfo->append(qs);
    bdateifehler=TRUE;
    return;
  }
  for(int i=0; i<11; i++){
    qs = listparameter.at(i);
    qs = qs.mid(2,2);
    wert = qs.toInt(&ok,16);
    if(ok){
      slnf[i]->setValue(wert);
      dslnf[i] = wert;
    }
  }
  for(int i=11; i<22; i++){
    qs = listparameter.at(i);
    qs = qs.mid(2,2);
    wert = qs.toInt(&ok,16);
    if(ok){
      slip3[i-11]->setValue(wert);
      dslip3[i-11] = wert;
    }
  }
  for(int i=22; i<26; i++){
    qs = listparameter.at(i);
    qs = qs.mid(2,2);
    wert = qs.toInt(&ok,16);
    if(ok){
      wert -= 0x80;
      sldds[i-22]->setValue(wert);
      dsldds[i-22] = wert;
    }
  }
}

void starcat::savescalparam(){
  QFile f;
  QString qs;
  
  f.setFileName(einst.scalfilename[starnr]);
  //qDebug("starcat::readparameter()");
  if(f.open(QIODevice::WriteOnly)){
    QTextStream ts(&f);
    for(int i=0; i<11; i++){
      qs.sprintf("00%02X00",dslnf[i]);
      ts << qs << "\r\n";
    }
    for(int i=0; i<11; i++){
      qs.sprintf("00%02X00",dslip3[i]);
      ts << qs << "\r\n";
    }
    for(int i=0; i<4; i++){
      qs.sprintf("00%02X00",dsldds[i]+0x80);
      ts << qs << "\r\n";
    }
    f.close();
  }
}

void starcat::setsparam(int wert, int index){
  dspparam[index]->hide();
  ldspparam[index]->hide();
  if(wert != 255){
    if(pxparam[index]){
      //qDebug("Palette");
      QPalette palette(dspparam[index]->palette());
      palette.setColor(QPalette::Button, Qt::red);
      dspparam[index]->setPalette(palette);
      dspparam[index]->setBackgroundRole( QPalette::Background );
      dspparam[index]->repaint();
      QString qs = ldspparam[index]->text();
      if(!qs.contains("X")){
        qs+="X";
        ldspparam[index]->setText(qs);
      }

    }
    dspparam[index]->show();
    ldspparam[index]->show();
    lparambeschr[index]->show();
    dspparam[index]->setMinimum(double(pmin[index])*pfaktor[index]);
    dspparam[index]->setMaximum(double(pmax[index])*pfaktor[index]);
    dspparam[index]->setSingleStep(pfaktor[index]);
    if(pfaktor[index]==1.0)dspparam[index]->setDecimals(0);
    if(pfaktor[index]<1.0)dspparam[index]->setDecimals(1);
    if(pfaktor[index]<0.1)dspparam[index]->setDecimals(2);
    dspparam[index]->setValue(double(wert)*pfaktor[index]);
    dspparam[index]->setToolTip(pbez[index]);
    lparambeschr[index]->setText(pbez[index]);
  }
}

void starcat::setuserid(){
  QString qs;
  
  for(int i=10; i<100; i++){
    qs.sprintf("%i.%i",puserid[i]/10,puserid[i]%10);
    ldspparam[i]->setText(qs);
  }
}

void starcat::setstarid(){
  QString qs;
  
  for(int i=10; i<100; i++){
    qs.sprintf("%i.%i",i/10,i%10);
    ldspparam[i]->setText(qs);
  }
}

void starcat::parameter2dsp(){
  QString qs2;
  
  QProgressDialog prd(tr("Parameter-Laden"), tr("Abbrechen"), 10, 99, this);
  prd.show();
  if(param_geladen){
    DSPcommando(108,1);
    for(int i=10;i<100;i++){
      prd.setValue(i);
      if(i==52 and cbdmoni->isChecked()){
        DSPcommando(52,2);
      }else{
        if(rbssb->isChecked()){
          if(rbgn->isChecked()){
            if(pssbgn[i] != 255){
              DSPcommando(i,pssbgn[i]);
              //qs2.sprintf("Paramssbgn ID: %i, Wert: %i",i, pssbgn[i]);
              //textinfo->append(qs2);
            }
          }
          if(rbge->isChecked()){
            if(pssbge[i] != 255){
              if(pssbge[i] == 254){
                DSPcommando(i,pssbgn[i]);
              }else{
                DSPcommando(i,pssbge[i]);
              }
              //qs2.sprintf("Paramssbge ID: %i, Wert: %i",i, pssbge[i]);
              //textinfo->append(qs2);
            }
          }
          if(rbrt->isChecked()){
            if(pssbrt[i] != 255){
              if(pssbrt[i] == 254){
                DSPcommando(i,pssbgn[i]);
              }else{
                DSPcommando(i,pssbrt[i]);
              }
              //qs2.sprintf("Paramssbrt ID: %i, Wert: %i",i, pssbrt[i]);
              //textinfo->append(qs2);
            }
          }
        }
        if(rbcw->isChecked()){
          if(rbgn->isChecked()){
            if(pcwgn[i] != 255){
              DSPcommando(i,pcwgn[i]);
              //qs2.sprintf("Paramcwgn ID: %i, Wert: %i",i, pcwgn[i]);
              //textinfo->append(qs2);
            }
          }
          if(rbge->isChecked()){
            if(pcwge[i] != 255){
              if(pcwge[i] == 254){
                DSPcommando(i,pcwgn[i]);
              }else{
                DSPcommando(i,pcwge[i]);
              }
              //qs2.sprintf("Paramcwge ID: %i, Wert: %i",i, pcwge[i]);
              //textinfo->append(qs2);
            }
          }
          if(rbrt->isChecked()){
            if(pcwrt[i] != 255){
              if(pcwrt[i] == 254){
                DSPcommando(i,pcwgn[i]);
              }else{
                DSPcommando(i,pcwrt[i]);
              }
              //qs2.sprintf("Paramcwrt ID: %i, Wert: %i",i, pcwrt[i]);
              //textinfo->append(qs2);
            }
          }
        }
      }
    }
    DSPcommando(108,0);
  }
}

void starcat::parameter2pic_alt(){
  uchar c, c1;
  QFile f;
  int re;
  int id;
  bool abbruch = FALSE;
  
  //f.setFileName("picparameter");
  //if(f.open(QIODevice::WriteOnly)){
  if(rs232isopen){
    //QDataStream ds(&f);
    buf.clear();
    for(int i=1; i<14; i++)buf.append(uchar('#'));
    buf.append(uchar(13));
    for(int i=10; i < 100; i++){
      if(pxparam[i]){
        buf.append(uchar(255));
      }else{
        buf.append(uchar(pssbgn[i]));
      }
    }
    for(int i=1; i<14; i++)buf.append(uchar('#'));
    buf.append(uchar(13));
    for(int i=10; i < 100; i++){
      if(pxparam[i]){
        buf.append(uchar(255));
      }else{
        buf.append(uchar(pssbge[i]));
      }
    }
    for(int i=1; i<14; i++)buf.append(uchar('#'));
    buf.append(uchar(13));
    for(int i=10; i < 100; i++){
      if(pxparam[i]){
        buf.append(uchar(255));
      }else{
        buf.append(uchar(pssbrt[i]));
      }
    }
    for(int i=1; i<14; i++)buf.append(uchar('#'));
    buf.append(uchar(13));
    for(int i=10; i < 100; i++){
      if(pxparam[i]){
        buf.append(uchar(255));
      }else{
        buf.append(uchar(pmax[i]));
      }
    }
    for(int i=1; i<14; i++)buf.append(uchar('#'));
    buf.append(uchar(13));
    for(int i=10; i < 100; i++){
      if(pxparam[i]){
        buf.append(uchar(255));
      }else{
        buf.append(uchar(pmin[i]));
      }
    }
    for(int i=1; i<14; i++)buf.append(uchar('#'));
    buf.append(uchar(13));
    for(int i=10; i < 100; i++){
      if(pxparam[i]){
        buf.append(uchar(255));
      }else{
        buf.append(uchar(pcwgn[i]));
      }
    }
    for(int i=1; i<14; i++)buf.append(uchar('#'));
    buf.append(uchar(13));
    for(int i=10; i < 100; i++){
      if(pxparam[i]){
        buf.append(uchar(255));
      }else{
        buf.append(uchar(pcwge[i]));
      }
    }
    for(int i=1; i<14; i++)buf.append(uchar('#'));
    buf.append(uchar(13));
    for(int i=10; i < 100; i++){
      if(pxparam[i]){
        buf.append(uchar(255));
      }else{
        buf.append(uchar(pcwrt[i]));
      }
    }
    for(int i=1; i<14; i++)buf.append(uchar('#'));
    buf.append(uchar(13));
    for(int i=10; i < 100; i++){
      if(pxparam[i]){
        buf.append(uchar(255));
      }else{
        buf.append(uchar(puserid[i]%10));
      }
    }
    for(int i=1; i<9; i++)buf.append(uchar('#'));
    //qDebug("%i",buf.count());
    while(defaultlesenrtty());
    id = 0;
    QProgressDialog prd(tr("Parameter -> STAR (G3XJP)"),tr("Abbrechen"),0,buf.count(), this);
    prd.show();
    do{
      //defaultlesenrtty();
      c = buf.at(id);
      picchar2rs232(c);
      id++;
      if(id == buf.count())abbruch=TRUE;
      //if(abbruch)break;
      re = 0;
      while(re < 1 and !abbruch){
        re = picmodem->readttybuffer(&c1,1);
        qApp->processEvents();//Austritt aus der Funktion fuer Events
        if(prd.wasCanceled ())return;
      }
      qApp->processEvents();//Austritt aus der Funktion fuer Events
      prd.setValue(id);
      if(prd.wasCanceled())return;
      if((c != c1)){
        QString qs,qs1,qs2;
        //qs.sprintf("Byte-Nr:%04X zum Pic gesendet:%X Antwort vom Pic:%X",id-1,c,c1);
        qs.sprintf("%04X",id-1);
        qs1.sprintf("%X",c);
        qs2.sprintf("%X",c1);
        qs = tr("Byte-Nr:") + qs + tr(" zum Pic gesendet:") + qs1 + tr("Antwort vom Pic:") + qs2;
        QMessageBox::about(this, tr("Error!"),qs);
        f.close();
        return;
      }
    }while(!abbruch);
    prd.setValue(buf.count());
  }
}

/*
void starcat::parameter2pic_neu(){
  uchar c, c1;
  QFile f;
  int re;
  int id;
  bool abbruch = FALSE;
  
  f.setFileName("picparameter");
  if(f.open(QIODevice::WriteOnly)){
    if(rs232isopen){
      QDataStream ds(&f);
      buf.clear();
      for(int i=10; i < 100; i++){
        if(pxparam[i]){
          buf.append(uchar(255));
        }else{
          buf.append(uchar(pssbgn[i]));
        }
      }
      for(int i=10; i < 100; i++){
        if(pxparam[i]){
          buf.append(uchar(255));
        }else{
          buf.append(uchar(pssbge[i]));
        }
      }
      for(int i=10; i < 100; i++){
        if(pxparam[i]){
          buf.append(uchar(255));
        }else{
          buf.append(uchar(pssbrt[i]));
        }
      }
      for(int i=10; i < 100; i++){
        if(pxparam[i]){
          buf.append(uchar(255));
        }else{
          buf.append(uchar(pcwgn[i]));
        }
      }
      for(int i=10; i < 100; i++){
        if(pxparam[i]){
          buf.append(uchar(255));
        }else{
          buf.append(uchar(pcwge[i]));
        }
      }
      for(int i=10; i < 100; i++){
        if(pxparam[i]){
          buf.append(uchar(255));
        }else{
          buf.append(uchar(pcwrt[i]));
        }
      }
      for(int i=10; i < 100; i++){
        if(pxparam[i]){
          buf.append(uchar(255));
        }else{
          buf.append(uchar(pmin[i]));
        }
      }
      for(int i=10; i < 100; i++){
        if(pxparam[i]){
          buf.append(uchar(255));
        }else{
          buf.append(uchar(pmax[i]));
        }
      }
      //qDebug("%i",buf.count());
      QProgressDialog prd("Parameter -> STAR (DL4JAL)","Abbrechen",0,buf.count(), this);
      prd.show();
      defaultlesenrtty();
      id = 0;
      do{
        //defaultlesenrtty();
        c = buf.at(id);
        picmodem->writeChar(c);
        id++;
        if(id == buf.count())abbruch=TRUE;
        //if(abbruch)break;
        re = 0;
        while(re != 1 and !abbruch){
          re = picmodem->readttybuffer(&c1,1);
          if((c != c1) and (re == 1)){
            QString qs;
            qs.sprintf("Adresse:%04X File:%X Pic:%X",id-1,c1,c);
            QMessageBox::about(this, tr("Error!"),qs);
            f.close();
            return;
          }
          qApp->processEvents();//Austritt aus der Funktion fuer Events
          prd.setValue(id);
          if(prd.wasCanceled())return;
        };
      }while(!abbruch);
      prd.setValue(buf.count());
    }
    f.close();
  }
}
*/

void starcat::clickdspbefehl(){
  QString sid;
  QString swert;
  int id;
  int wert;
  bool ok;
  
  //qDebug("starcat::readparameter()");
  sid = dspid->text();
  swert = dspwert->text();
  id = sid.toInt(&ok);
  wert = swert.toInt(&ok);
  DSPcommando(id,wert);
  //qDebug("%i",uchar('~'));
}

void starcat::tstopdspbef(){
  int wertneu;
  int wertalt=0;
  
  for(int i=10; i<100; i++){
    wertneu = qRound(dspparam[i]->value());
    if(wertneu != 255)wertneu = qRound(dspparam[i]->value()/pfaktor[i]);
    //if(i==64)qDebug("wertneu %i", wertneu);
    if(rbssb->isChecked()){
      if(rbgn->isChecked()){
        wertalt = pssbgn[i];
        if(wertalt != 255)pssbgn[i] = wertneu;
      }
      if(rbge->isChecked()){
        if(pssbge[i]==254){
          wertalt = pssbgn[i];
          if(wertalt != 255)pssbgn[i] = wertneu;
        }else{
          wertalt = pssbge[i];
          if(wertalt != 255)pssbge[i] = wertneu;
        };
      }
      if(rbrt->isChecked()){
        if(pssbrt[i]==254){
          wertalt = pssbgn[i];
          if(wertalt != 255)pssbgn[i] = wertneu;
        }else{
          wertalt = pssbrt[i];
          if(wertalt != 255)pssbrt[i] = wertneu;
        };
      }
    }
    if(rbcw->isChecked()){
      if(rbgn->isChecked()){
        wertalt = pcwgn[i];
        if(wertalt != 255)pcwgn[i] = wertneu;
      }
      if(rbge->isChecked()){
        if(pcwge[i]==254){
          wertalt = pcwgn[i];
          if(wertalt != 255)pcwgn[i] = wertneu;
        }else{
          wertalt = pcwge[i];
          if(wertalt != 255)pcwge[i] = wertneu;
        };
      }
      if(rbrt->isChecked()){
        if(pcwrt[i]==254){
          wertalt = pcwgn[i];
          if(wertalt != 255)pcwgn[i] = wertneu;
        }else{
          wertalt = pcwrt[i];
          if(wertalt != 255)pcwrt[i] = wertneu;
        };
      }
    }
    //if(i==64)qDebug("wertneu %i, wertalt %i", wertneu, wertalt);
    if(bsmparam){
      if(i == 68){
        timerdspbef->stop();
        return;
      }
    }
    if(wertneu != wertalt){
      //qDebug("DSP %i, wertneu %i", i, wertneu);
      if(pxparam[i]){
        bxparamgeaendert = TRUE;
        buttonxparamsave->setEnabled(TRUE);
      }else{
        bparamgeaendert = TRUE;
        buttonparamsave->setEnabled(TRUE);
      }
      DSPcommando(i,wertneu);
    }
  }
  timerdspbef->stop();
}

void starcat::dspbefehl(){
  if(param_geladen)timerdspbef->start(200);
}

void starcat::setb1(){
  if(b1->isChecked()){
    DSPcommando(1,1);
  }else{
    DSPcommando(1,0);
  }
}

void starcat::setb2(){
  if(b2->isChecked()){
    DSPcommando(255,1);
  }else{
    DSPcommando(255,0);
  }
}

void starcat::setb3(){
  if(b3->isChecked()){
    DSPcommando(3,1);
  }else{
    DSPcommando(3,0);
  }
}

void starcat::setb4(){
  if(b4->isChecked()){
    DSPcommando(4,1);
  }else{
    DSPcommando(4,0);
  }
}

void starcat::setb5(){
  if(b5->isChecked()){
    DSPcommando(5,1);
  }else{
    DSPcommando(5,0);
  }
}

void starcat::setb6(){
  if(b6->isChecked()){
    DSPcommando(6,1);
    b6->setText(tr("6 Fil.6.1"));
  }else{
    DSPcommando(6,0);
    b6->setText(tr("6 Fil.6.2"));
  }
}

void starcat::setb7(){
  if(b7->isChecked()){
    DSPcommando(7,1);
  }else{
    DSPcommando(7,0);
  }
}

void starcat::setb9(){
  if(b9->isChecked()){
    DSPcommando(9,1);
  }else{
    DSPcommando(9,0);
  }
}

void starcat::setparamgruppecw(){
  rbcw->setChecked(TRUE);
  rbssb->setChecked(FALSE);
  //qDebug("starcat::setparamgruppecw()");
  if(rblsb->isChecked())DSPcommando(2,2);
  if(rbusb->isChecked())DSPcommando(2,3);
  parametersetzen();
  parameter2dsp();
  b4->setText(tr("4 QRO"));
  b7->setText(tr("7 QSK"));
  b9->setText(tr("9 CW Spot"));
}

void starcat::setparamgruppessb(){
  rbssb->setChecked(TRUE);
  rbcw->setChecked(FALSE);
  //qDebug("starcat::setparamgruppessb()");
  if(rblsb->isChecked())DSPcommando(2,0);
  if(rbusb->isChecked())DSPcommando(2,1);
  parametersetzen();
  parameter2dsp();
  b4->setText(tr("4 A-Notch"));
  b7->setText(tr("7 VOX"));
  b9->setText(tr("9 RF Clip"));
}

void starcat::setparamusb(){
  rbusb->setChecked(TRUE);
  rblsb->setChecked(FALSE);
  if(rbssb->isChecked())DSPcommando(2,1);
  if(rbcw->isChecked())DSPcommando(2,3);
}

void starcat::setparamlsb(){
  rblsb->setChecked(TRUE);
  rbusb->setChecked(FALSE);
  if(rbssb->isChecked())DSPcommando(2,0);
  if(rbcw->isChecked())DSPcommando(2,2);
}

void starcat::setparamgruppegn(){
  rbgn->setChecked(TRUE);
  rbge->setChecked(FALSE);
  rbrt->setChecked(FALSE);
  //qDebug("starcat::setparamgruppegn()");
  parametersetzen();
  parameter2dsp();
}

void starcat::setparamgruppege(){
  rbge->setChecked(TRUE);
  rbgn->setChecked(FALSE);
  rbrt->setChecked(FALSE);
  //qDebug("starcat::setparamgruppege()");
  parametersetzen();
  parameter2dsp();
}

void starcat::setparamgruppert(){
  rbrt->setChecked(TRUE);
  rbgn->setChecked(FALSE);
  rbge->setChecked(FALSE);
  //qDebug("starcat::setparamgruppert()");
  parametersetzen();
  parameter2dsp();
}

void starcat::clickrxeqladen(){
  QFile f;
  bool dateiende = FALSE;
  int zeilennr;
  int eqwert;
  QString qs;
  QString zeile;
  bool ok;
  
  //qDebug("starcat::clickrxeqladen()");
  f.setFileName(einst.rxeqfilename[starnr]);
  if(f.open(QIODevice::ReadOnly)){
    QTextStream ts(&f);
    zeilennr = 0;
    do{
      zeile = ts.readLine();
      eqwert = zeile.toInt(&ok,16);
      slrx[zeilennr]->setValue(star2sl(eqwert));
      //qDebug("zeile %i; wert: %x",zeilennr,eqwert);
      zeilennr++;
    }while(!ts.atEnd() and !dateiende);
    f.close();
    rxeqdateigeladen = TRUE;
    grxeq->setEnabled(TRUE);
    buttonrxeq2pic->setEnabled(TRUE);
  }else{
    qs = tr("Datei \"") + einst.rxeqfilename[starnr] + tr("\" nicht gefunden!");
    QMessageBox::critical(this, tr("Datei nicht gefunden!"),qs);
    bdateifehler = TRUE;
    buttonrxeqspeichern->setEnabled(FALSE);
    rxeqdateigeladen = FALSE;
    grxeq->setEnabled(FALSE);
    buttonrxeq2pic->setEnabled(FALSE);
  }
}

void starcat::clicktxeqladen(){
  QFile f;
  bool dateiende = FALSE;
  int zeilennr;
  int eqwert;
  QString qs;
  QString zeile;
  bool ok;
  
  //qDebug("starcat::clicktxeqladen()");
  f.setFileName(einst.txeqfilename[starnr]);
  if(f.open(QIODevice::ReadOnly)){
    QTextStream ts(&f);
    zeilennr = 0;
    do{
      zeile = ts.readLine();
      eqwert = zeile.toInt(&ok,16);
      sltx[zeilennr]->setValue(star2sl(eqwert));
      //qDebug("zeile %i; wert: %x",zeilennr,eqwert);
      zeilennr++;
    }while(!ts.atEnd() and !dateiende);
    f.close();
    txeqdateigeladen = TRUE;
    gtxeq->setEnabled(TRUE);
    buttontxeq2pic->setEnabled(TRUE);
  }else{
    qs = tr("Datei \"") + einst.txeqfilename[starnr] + tr("\" nicht gefunden!");
    QMessageBox::critical(this, tr("Datei nicht gefunden!"),qs);
    bdateifehler = TRUE;
    buttontxeqspeichern->setEnabled(FALSE);
    txeqdateigeladen = FALSE;
    gtxeq->setEnabled(FALSE);
    buttontxeq2pic->setEnabled(FALSE);
  }
}

int starcat::star2sl(int w){
  int waus;
  
  switch(w){
    case 0x7fff00: waus = 0; break;
    case 0x721500: waus = -1; break;
    case 0x65ad00: waus = -2; break;
    case 0x5a9e00: waus = -3; break;
    case 0x50c300: waus = -4; break;
    case 0x47fb00: waus = -5; break;
    case 0x402700: waus = -6; break;
    case 0x392d00: waus = -7; break;
    case 0x32f500: waus = -8; break;
    case 0x2d6b00: waus = -9; break;
    case 0x287a00: waus = -10; break;
    case 0x241300: waus = -11; break;
    case 0x202700: waus = -12; break;
    case 0x000000: waus = -13; break;
    default: waus = 0; break;
  }
  return waus;
}

int starcat::sl2star(int w){
  int waus;
  
  switch(w){
    case 0: waus = 0x7fff00; break;
    case -1: waus = 0x721500; break;
    case -2: waus = 0x65ad00; break;
    case -3: waus = 0x5a9e00; break;
    case -4: waus = 0x50c300; break;
    case -5: waus = 0x47fb00; break;
    case -6: waus = 0x402700; break;
    case -7: waus = 0x392d00; break;
    case -8: waus = 0x32f500; break;
    case -9: waus = 0x2d6b00; break;
    case -10: waus = 0x287a00; break;
    case -11: waus = 0x241300; break;
    case -12: waus = 0x202700; break;
    case -13: waus = 0x000000; break;
    default: waus = 0x7fff00; break;
  }
  return waus;
}

void starcat::clickrxeq2pic(){
  QString qs, k1, k2;
  int eqpoint;
  int eqwert;
  uchar bhigh;
  uchar blow;
  bool ok;
  
  if(grxeq->isEnabled()){
    //qDebug("starcat::clickrxeq2pic()");
    QProgressDialog prd(tr("RX Equalizer in DSP laden"), tr("Abbrechen"), 0, 31, this);
    prd.show();
    lrxstatus->setText(tr("ONLINE mit STAR!"));
    grxeq->setEnabled(FALSE);
    DSPcommando(24,1); //RX EQ on
    DSPcommando(109,0);
    for(int i=0; i<31; i++){
      prd.setValue(i);
      eqpoint = slrx[i]->value();
      eqwert = sl2star(eqpoint);
      qs.sprintf("%X",eqwert);
      k1 = qs.left(2);
      k2 = qs.mid(2,2);
      bhigh = k1.toInt(&ok,16);
      blow = k2.toInt(&ok,16);
      DSPcommando(110,bhigh);
      DSPcommando(112,blow);
    }
    DSPcommando(113,0);
    lrxstatus->setText("");
    grxeq->setEnabled(TRUE);
  }
}

void starcat::clicktxeq2pic(){
  QString qs, k1, k2;
  int eqpoint;
  int eqwert;
  uchar bhigh;
  uchar blow;
  bool ok;
  
  if(gtxeq->isEnabled()){
    //qDebug("starcat::clicktxeq2pic()");
    QProgressDialog prd(tr("TX Equalizer in DSP laden"), tr("Abbrechen"), 0, 31, this);
    prd.show();
    ltxstatus->setText(tr("ONLINE mit STAR!"));
    gtxeq->setEnabled(FALSE);
    DSPcommando(95,1); //TX EQ on
    DSPcommando(109,1);
    for(int i=0; i<31; i++){
      prd.setValue(i);
      eqpoint = sltx[i]->value();
      eqwert = sl2star(eqpoint);
      qs.sprintf("%X",eqwert);
      k1 = qs.left(2);
      k2 = qs.mid(2,2);
      bhigh = k1.toInt(&ok,16);
      blow = k2.toInt(&ok,16);
      DSPcommando(110,bhigh);
      DSPcommando(112,blow);
    }
    DSPcommando(113,1);
    ltxstatus->setText("");
    gtxeq->setEnabled(TRUE);
  }
}

void starcat::clickrxeqspeichern(){
  QFile f;
  QString qs, s, s1;
  int eqwert;

  s = einst.rxeqfilename[starnr];
  if(!einst.rxeqfilename[starnr].contains(".dat")) s += ".dat";
  f.setFileName(s);
  if(f.exists()){
    f.rename(s+"$");
  }
  f.setFileName(s);
  if(f.open(QIODevice::WriteOnly)){
    QTextStream ts(&f);
    for(int i=0; i<31; i++){
      eqwert = slrx[i]->value();
      qs.sprintf("%06X", sl2star(eqwert)); //6-stellig mit fuehrenden Nullen
      ts << qs << "\r\n";
    }
    buttonrxeqspeichern->setEnabled(FALSE);
  }
  f.close();
}

void starcat::clicktxeqspeichern(){
  QFile f;
  QString qs, s, s1;
  int eqwert;

  s = einst.txeqfilename[starnr];
  if(!einst.txeqfilename[starnr].contains(".dat")) s += ".dat";
  f.setFileName(s);
  if(f.exists()){
    f.rename(s+"$");
  }
  f.setFileName(s);
  if(f.open(QIODevice::WriteOnly)){
    QTextStream ts(&f);
    for(int i=0; i<31; i++){
      eqwert = sltx[i]->value();
      qs.sprintf("%06X", sl2star(eqwert)); //6-stellig mit fuehrenden Nullen 
      ts << qs << "\r\n";
    }
    buttontxeqspeichern->setEnabled(FALSE);
  }
  f.close();
}

void starcat::clickifstep(){
  QString step1qs = tr(
  "<b>SCHRITT 1</b><br>"
  "Laden und Starten der letzten DSP-Softwarerelease in den STAR<br>"
  "Benutze den PC oder auch den PIC (Power ON)<br>"
  "<br>"
  "Schalte auf das 20m-Band ... und in den \"Best NF mode\"<br>"
  "<br>"
  "Dann verbinde die RS232-DSP mit dem RS232-PC."
  );
  QString step2qs = tr(
  "<b>SCHRITT 2</b><br>"
  "Die Parameter fuer die Kalibrierung werden in den STAR geladen<br>"
  "Das dauert etwas... Bitte warten!"
  );
  QString step21qs = tr(
  "<b>SCHRITT 2</b><br>"
  "Die Anzeige oberhalb muesste jetzt etwas anzeigen.<br>"
  "Du hoerst das Rauschen des Empfaengers<br>"
  "Eventuell kannst Du im Bereich \"DSP-Parameter\" die Lautstaerke reguliern<br>"
  "Anschliessend wieder hier an diese Stelle wechseln. <br>"
  "Ist keine Anzeige vorhanden \"ABBRECHEN\" und von vorn beginnen!!"
  );
  QString step3qs = tr(
  "<b>SCHRITT 3</b><br>"
  "<b>Test der RS232 beide Wege</b><br>"
  "Das dauert etwas... Bitte warten!"
  );
  QString step31qs = tr(
  "<b>SCHRITT 3</b><br>"
  "<b>Test der RS232 beide Wege</b><br>"
  "Ergebnis der RS232 Kontrolle: Es arbeiten beide Wege."
  );
  QString step4qs = tr(
  "<b>SCHRITT 4</b><br>"
  "<b>Einstellung der Regler RV1 und RV2</b><br>"
  "RV1 Schleifer auf GND drehen<br>"
  "RV2 Schleifer auf R38/C40 drehen"
  );
  QString step5qs = tr(
  "<b>SCHRITT 5</b><br>"
  "<b>Einstellung der Regler RV1</b><br>"
  "Einstellung RX 20m-Band und 3kHz Bandbreite.<br>"
  "RV1 langsam drehen bis zum Rauschmaximum<br>"
  "Der Pegel sollte zwischen 23dB und 25dB betragen"
  );
  QString step6qs = tr(
  "<b>SCHRITT 6</b><br>"
  "<b>Einstellung der Regler RV1</b><br>"
  "Der Pegel sollte zwischen 23dB und 25dB betragen<br>"
  "Messung des Pegels..."
  );
  QString step61qs = tr(
  "<b>SCHRITT 6</b><br>"
  "<b>Einstellung der Regler RV1</b><br>"
  "Der Pegel sollte zwischen 23dB und 25dB betragen"
  );
  QString step7qs = tr(
  "<b>SCHRITT 7</b><br>"
  "<b>Einstellung der Regler RV1 und RV2</b><br>"
  "Bitte am RX-Eingang ein Signal anlegen. Den Pegel erhoehen bis<br>"
  "Die Anzeige zwischen 73dB und 80dB anzeigt."
  );
  QString step71qs = tr(
  "<b>SCHRITT 7</b><br>"
  "<b>Einstellung der Regler RV1 und RV2</b><br>"
  "Pegelmessung ..."
  );
  QString step72qs = tr(
  "<b>SCHRITT 7</b><br>"
  "<b>Einstellung der Regler RV1 und RV2</b>"
  );
  QString step8qs = tr(
  "<b>SCHRITT 8</b><br>"
  "<b>Einstellung der Regler RV1 und RV2</b><br>"
  "Die Verstaerkung des AD603 wird im naechsten Schritt <br>"
  "auf das Minimum reduziert. Mit dem Regler RV2 wird auf das <br>"
  "Minimum an der Pegelanzeige eingestellt."
  );
  QString step81qs = tr(
  "<b>SCHRITT 8</b><br>"
  "<b>Einstellung der Regler RV1 und RV2</b><br>"
  "Die Verstaerkung des AD603 wurde auf das Minimum reduziert.<br>"
  "Jetzt mit dem Regler RV2 auf Minimum an der Pegelanzeige <br>"
  "einstellen."
  );
  QString step82qs = tr(
  "<b>SCHRITT 9</b><br>"
  "<b>Ermittlung des Pegelbereiches vom AD603</b><br>"
  "Der Pegel in Minimumeinstellung wird gemessen."
  );
  QString step83qs = tr(
  "<b>SCHRITT 9</b><br>"
  "<b>Ermittlung des Pegelbereiches vom AD603</b><br>"
  "Pegelmessung ..."
  );
  QString step84qs = tr(
  "<b>SCHRITT 9</b><br>"
  "<b>Ermittlung des Pegelbereiches vom AD603</b><br>"
  "Ein Pegelbereich von 35db - 41dB ist OK. 39dB sind erreichbar,<br>"
  "aber mehr als 39dB ist besser.<br>"
  );
  QString step9qs = tr(
  "<b>SCHRITT 10</b><br>"
  "<b>Im naechsten Schritt werden die 64 DAC Wandlerstufen <br>"
  "passend zum AD603 ermittelt</b><br>"
  "Die Messungen dauern etwa 1 Minute!"
  );
  QString step91qs = tr(
  "<b>SCHRITT 10</b><br>"
  "<b>Einstellung der 64 DAC Wandlerstufen passend zum AD603</b><br>"
  "Messung laeuft ..."
  );
  QString step10qs = tr(
  "<b>SCHRITT 11</b><br>"
  "Alle Messungen sind komplett<br>"
  "Im naechsten Schritt wird die neue Datei zusammengestellt."
  );
  QString step11qs = tr(
  "<b>SCHRITT 12</b><br>"
  "<b>Speichern der Datei AD603.dat</b><br>"
  );
  QString step12qs = tr(
  "<b>SCHRITT 12</b><br>"
  "<b>Datei AD603.dat wurde ersetzt</b><br>"
  );
  QString step13qs = tr(
  "<b>Erfolgreich Abgeschlossen</b><br>"
  );
  QString stepweiterqs = tr(
  "<br>"
  "OK? \"WEITER\" druecken!"
  );
  QString qs;
  QFile f;
  
  //qDebug("starcat::clickifstep()");
  //qDebug("Step %i",ifstep);
  stepinfo->clear();
  buttonifstep->setEnabled(FALSE);
  switch(ifstep){
    case 0: 
      stepinfo->append(step1qs);
      stepinfo->append(stepweiterqs);
      buttonifstep->setText(tr("WEITER!"));
      break;
    case 1: 
      stepinfo->append(step2qs);
      bsmparam = FALSE;
      bxparam = FALSE;
      readparameter(einst.standardparameterfilename[starnr]);
      pssbgn[21] = 70; //Lautstaerke reduziern default = 94 das ist zu laut
      dspparam[21]->setValue(double(70));
      for(int i=10; i<100; i++){
        if(i!=21)dspparam[i]->setEnabled(FALSE);
      }
      DSPcommando(108,1);
      for(int i=1; i<10; i++)DSPcommando(i,0);// Alle Switches OFF
      for(int i=10; i<100; i++){
        if(pssbgn[i] != 255)DSPcommando(i, pssbgn[i]);
      }
      DSPcommando(108,0);
      while(defaultlesenrtty()); //RS232 Buffer leeren
      rxindex = 0;
      DSPcommando(52,2);//Monitor EIN
      DSPcommando(57,8);//Manual PreADC max
      DSPcommando(107,64);
      timerempfangRS232->start(100);
      stepinfo->clear();
      stepinfo->append(step21qs);
      stepinfo->append(stepweiterqs);
    break;
    case 2: 
      stepinfo->append(step3qs);
      delay(1000);
      DSPcommando(55,3);
      DSPcommando(57,6);
      bstart = TRUE;
      messzyklen = 50;
      bende = FALSE;
    break;
    case 3: 
      stepinfo->append(step3qs);
      delay(1000);
      DSPcommando(57,8);
      bstart = TRUE;
      messzyklen = 50;
      bende = FALSE;
    break;
    case 4: 
      stepinfo->append(step31qs);
      stepinfo->append(stepweiterqs);
    break;
    case 5: 
      stepinfo->append(step4qs);
      stepinfo->append(stepweiterqs);
    break;
    case 6: 
      stepinfo->append(step5qs);
      stepinfo->append(stepweiterqs);
    break;
    case 7: 
      stepinfo->append(step6qs);
      delay(1000);
      bstart = TRUE;
      messzyklen = 10;
      bende = FALSE;
      messergebnis = 0.0;
    break;
    case 8: 
      stepinfo->append(step61qs);
      qs.sprintf(" %2.2fdB",messergebnis);
      stepinfo->append(tr("Der Rauschpegel betraegt:") + qs);
      stepinfo->append(stepweiterqs);
    break;
    case 9: 
      stepinfo->append(step7qs);
      stepinfo->append(stepweiterqs);
    break;
    case 10: 
      stepinfo->append(step71qs);
      bstart = TRUE;
      messzyklen = 10;
      bende = FALSE;
      messergebnis = 0.0;
    break;
    case 11:
      stepinfo->append(step72qs);
      qs.sprintf(" %2.2fdB",messergebnis);
      messung1 = messergebnis;
      stepinfo->append(tr("Die Pegelanzeige betraegt:") + qs);
      if(messergebnis < 73.0){
        QMessageBox::critical(this, tr("Fehler bei der ZF-Kalibrierung!"),"Der Pegel ist zu niedrig!");
        ifstep = 9;
      }
      if(messergebnis > 80.0){
        QMessageBox::critical(this, tr("Fehler bei der ZF-Kalibrierung!"),"Der Pegel ist zu hoch!");
        ifstep = 9;
      }
      if(ifstep!=9)stepinfo->append(stepweiterqs);
    break;
    case 12:
      stepinfo->append(step8qs);
      stepinfo->append(stepweiterqs);
    break;
    case 13:
      stepinfo->append(step81qs);
      stepinfo->append(stepweiterqs);
      DSPcommando(107,0);
      delay(1000);
    break;
    case 14:
      stepinfo->append(step82qs);
      stepinfo->append(stepweiterqs);
      bstart = TRUE;
      messzyklen = 10;
      bende = FALSE;
      messergebnis = 0.0;
    break;
    case 15:
      stepinfo->append(step83qs);
      qs.sprintf(" %2.2fdB",messergebnis);
      stepinfo->append(tr("Der Pegel AD603 minimale Verstaerkung:") + qs);
      stepinfo->append(stepweiterqs);
    break;
    case 16:
      stepinfo->append(step84qs);
      messung2 = messergebnis;
      qs.sprintf(" %2.2fdB",messung1);
      stepinfo->append(tr("Der Pegel AD603 maximale Verstaerkung:") + qs);
      qs.sprintf(" %2.2fdB",messung2);
      stepinfo->append(tr("Der Pegel AD603 minimale Verstaerkung:") + qs);
      qs.sprintf(" %2.2fdB",messung1 - messung2);
      stepinfo->append(tr("Der Pegelbereich des AD603 betraegt  :") + qs);
      stepinfo->append(stepweiterqs);
    break;
    case 17:
      stepinfo->append(step9qs);
      stepinfo->append(stepweiterqs);
    break;
    case 18:
      stepinfo->append(step91qs);
      for(int i=0; i<64; i++){
        calcurve[i] = 0.0;
      }
      bstart = TRUE;
      messzyklen = 15;
      bende = FALSE;
      messergebnis = 0.0;
      ccidx = 63;
      DSPcommando(107,ccidx);
    break;
    case 19:
      stepinfo->append(step10qs);
      stepinfo->append(stepweiterqs);
      DSPcommando(107,64);//AD603 von manuell auf auto
      DSPcommando(55,0);//GAIN von manuell auf auto
      int ix;
      int pfdata;
      int gotcha;
      for(int i=0; i<47; i++){
        op[i] = 0;
      }
      for(int j=0; j<46; j++){
        pfdata = 99;
        gotcha = 0;
        for(int i=1; i<64; i++){
          ix = qRound(calcurve[i]);
          if(ix >= j){
            gotcha++;
            if(gotcha == 1)pfdata = i;
          }
        }
        op[j+1]=pfdata;
      }
      for(int i=1; i<47; i++){
        if(op[i+1] == 99){
          op[i]=63;
          break;
        }
      }
      f.setFileName(homedir.filePath("AD603_1.dat"));
      if(f.open(QIODevice::WriteOnly)){
        QTextStream ts(&f);
        for(int i=1; i<47; i++){
          qs.sprintf("00%02X00", op[i]);
          ts << qs << "\r\n";
        }
      }
      f.close();
    break;
    case 20:
      stepinfo->append(step11qs);
      stepinfo->append(stepweiterqs);
    break;
    case 21:
      stepinfo->append(step12qs);
      stepinfo->append(stepweiterqs);
      f.setFileName(einst.ad603filename[starnr]);
      if(f.open(QIODevice::WriteOnly)){
        QTextStream ts(&f);
        for(int i=1; i<47; i++){
          qs.sprintf("00%02X00", op[i]);
          ts << qs << "\r\n";
        }
      }
      f.close();
    break;
    case 22:
      stepinfo->append(step13qs);
      stepinfo->append(stepweiterqs);
    break;
    case 23:
      clickifabbruch();
    break;
  }
  buttonifstep->setEnabled(TRUE);
  if(ifstep != 23)ifstep++;
}

void starcat::clicksmstep(){
  QString step1qs = tr(
  "<b>SCHRITT 1</b><br>"
  "Die DSP-Software muss funtionieren. Und der \"DDS-Paramter 6.5\"<br>"
  "\"S meter zero\" muss richtig eingestellt sein. Das wird am STAR<br>"
  "voher richtig eingestellt. Im naechsten Schritt werden die<br>"
  "Standartparameter geladen und die Kalibrierdatei.<br>"
  "<br>"
  "Verbinde die RS232 vom STAR mit dem PC."
  );
  QString step2qs = tr(
  "<b>SCHRITT 2</b><br>"
  "Es werden die Dateien geladen und die Parameter in den DSP geladen.<br>"
  );
  QString step3qs = tr(
  "<b>SCHRITT 3</b><br>"
  "Die Anzeige der S-Meterdaten muesste OBEN zu sehne sein.<br>"
  "Jetzt \"50uV, -73dBm\" an den Eingang vom STAR anlegen und <br>"
  "pro Band die richtigen Werte ermitteln. Getrennt nach IP3 und NF.<br>"
  "Die Anzeige muss bei der richtigen Einstellung <b>\"56 dB\"</b> anzeigen.<br>"
  "Sind alle Werte eingestellt kann die Kalibrierdatei abgespeichert werden!<br>"
  "Als Abschluss <b>\"SAVE Daten\"</b> druecken!<br>"
  "Der DSP-Parameter \"S-Meter cal 6.4\" wird auf \"Value = 0\" gesetzt!"
  );
  QString step4qs = tr(
  "<b>SCHRITT 4</b><br>"
  "Die Kalibrierdatei wurde neu erzeugt.<br>"
  "Der DSP-Parameter \"S-Meter cal 6.4\" muss auf \"Value = 0\" gesetzt werden!<br>"
  "ENDE"
  "<br>"
  "\"WEITER\" druecken!"
  );
  QString stepweiterqs = tr(
  "<br>"
  "Ist alles getan? \"WEITER\" druecken!"
  );
  QString qs;
  QFile f;
  
  //qDebug("starcat::clicksmstep()");
  //qDebug("Step sm %i",ifstep);
  stepsminfo->clear();
  buttonsmstep->setEnabled(FALSE);
  switch(smstep){
    case 0: 
      stepsminfo->append(step1qs);
      stepsminfo->append(stepweiterqs);
      buttonsmstep->setText(tr("WEITER!"));
      break;
    case 1:
      stepsminfo->append(step2qs);
      bsmparam = TRUE;
      readscalparam();
      bxparam = FALSE;
      readparameter(einst.parameterfilename[starnr]);
      pssbgn[21] = 60; //Lautstaerke reduziern default = 94 das ist zu laut
      dspparam[21]->setValue(double(60));
      for(int i=10; i<100; i++){
        if(i!=21)dspparam[i]->setEnabled(FALSE);
      }
      DSPcommando(108,1);
      for(int i=1; i<10; i++)DSPcommando(i,0);// Alle Switches OFF
      for(int i=10; i<100; i++){
        if(i != 68){
          if(pssbgn[i] != 255)DSPcommando(i, pssbgn[i]);
        }
      }
      DSPcommando(108,0);
      while(defaultlesenrtty()); //RS232 Buffer leeren
      rxindex = 0;
      DSPcommando(52,2); //Monitor EIN
      timerempfangRS232->start(100);
      stepsminfo->append(stepweiterqs);
      break;
    case 2: 
      stepsminfo->append(step3qs);
      buttonsmstep->setText(tr("SAVE Daten"));
      break;
    case 3: 
      stepsminfo->append(step4qs);
      savescalparam();
      //Volle S-Meter Kalibrierung Parameter 6.4=0
      pssbgn[64] = 0;
      dspparam[64]->setValue(double(0));
//      clickparamsave();
      buttonsmstep->setText(tr("WEITER!"));
      break;
  }
  smstep++;
  buttonsmstep->setEnabled(TRUE);
  if(smstep == 4){
    clicksmabbruch();
  }
}

void starcat::tstopempfangRS232(){
  uchar abuffer[256];
  int a=0;
  int rx2index;
  int bg;
  QString qs;

  if (rs232isopen){
    a = picmodem->readttybuffer(abuffer, 256);
  }
  leerdurchlauf++;
  //qDebug("a= %i",a);
  for(int i=0; i<a; i++){
    leerdurchlauf = 0;
    rxbuffer[rxindex]=abuffer[i];
    rxindex++;
    if(rxindex==256)rxindex=0;
  }
  if(rxindex >= 26){
    rx2index = rxindex - 26;
    while(rx2index < rxindex){
      if(rxbuffer[rx2index] == '~'){
        rx2index++;
        if(rxbuffer[rx2index] == '~'){
          //qDebug("gefunden");
          adc = rxbuffer[rx2index+1] * 256 + rxbuffer[rx2index+2];
          hangstuff = rxbuffer[rx2index+3];
          dac = rxbuffer[rx2index+4] * 256 + rxbuffer[rx2index+5];
          devbyte1 = rxbuffer[rx2index+6] * 256 + rxbuffer[rx2index+7];
          devbyte2 = rxbuffer[rx2index+8] * 256 + rxbuffer[rx2index+9];
          devbyte3 = rxbuffer[rx2index+10] * 256 + rxbuffer[rx2index+11];
          devbyte4 = rxbuffer[rx2index+12] * 256 + rxbuffer[rx2index+13];
          devbyte5 = rxbuffer[rx2index+14] * 256 + rxbuffer[rx2index+15];
          devbyte6 = rxbuffer[rx2index+16] * 256 + rxbuffer[rx2index+17];
          sigdb = rxbuffer[rx2index+18];
          spk = rxbuffer[rx2index+19];
          uartADCgain = uchar(rxbuffer[rx2index+20]/16);
          gn = rxbuffer[rx2index+22];
          //===============================================================
          //pbagc->setValue(sigdb);
          //===============================================================
          rxindex = 0;
          if(hangstuff > 127){hangstuff -= 128;TorR = 1;}else{TorR = 0;}
          if(hangstuff > 63){hangstuff -= 63;HANG = 1;}else{HANG = 0;}
          bg = devbyte1;
          if(bg == 0){
            dB = 90;
          }else{
            dB = qRound(8.685889638000001 * log(pow(2,15) / double(bg)));
            dB = 90 - dB;
          }
          //qDebug("uartADCgain: %i",uartADCgain);
          if(!bsmparam){
            pbagc->setValue(dB);
          }else{
            pbsmagc->setValue(sigdb);
          }
          switch(smstep){
            case 2:
              grsm->setEnabled(TRUE);
              clicksmstep();
            break;
          }
          if(bstart){
            switch(ifstep){
              case 3:
                //qDebug("uartADCgain1: %i",uartADCgain);
                if(uartADCgain == 6){
                  bende = TRUE;
                  bstart = FALSE;
                  clickifstep();
                }
                messzyklen--;
                if(messzyklen == 0){
                  bende = TRUE;
                  bstart = FALSE;
                  fehleranzeige(3);
                  clickifabbruch();
                }
              break;
              case 4:
                //qDebug("uartADCgain2: %i",uartADCgain);
                if(uartADCgain == 8){
                  bende = TRUE;
                  bstart = FALSE;
                  clickifstep();
                }
                messzyklen--;
                if(messzyklen == 0){
                  bende = TRUE;
                  bstart = FALSE;
                  fehleranzeige(4);
                  clickifabbruch();
                }
              break;
              case 8:
                messergebnis += double(dB);
                messzyklen--;
                if(messzyklen == 0){
                  messergebnis = messergebnis / 10.0;
                  bende = TRUE;
                  bstart = FALSE;
                  clickifstep();
                }
              break;
              case 11:
                messergebnis += double(dB);
                messzyklen--;
                if(messzyklen == 0){
                  messergebnis = messergebnis / 10.0;
                  bende = TRUE;
                  bstart = FALSE;
                  clickifstep();
                }
              break;
              case 15:
                messergebnis += double(dB);
                messzyklen--;
                if(messzyklen == 0){
                  messergebnis = messergebnis / 10.0;
                  bende = TRUE;
                  bstart = FALSE;
                  clickifstep();
                }
              break;
              case 19:
                if(messzyklen < 11)messergebnis += double(dB);
                messzyklen--;
                if(messzyklen == 0){
                  messergebnis = messergebnis / 10.0;
                  calcurve[ccidx] = messergebnis - messung2;
                  if(calcurve[ccidx] < 0.0)calcurve[ccidx]=0.0;
                  messergebnis = 0.0;
                  messzyklen = 15;
                  ccidx--;
                  if(ccidx == -1){
                    bende = TRUE;
                    bstart = FALSE;
                    clickifstep();
                  }else{
                    DSPcommando(107,ccidx);
                    qs.sprintf("calcurve[%i] = %2.2f",ccidx+1,calcurve[ccidx+1]);
                    stepinfo->append(qs);
                  }
                }
              break;
            }
          }
        }
      }else{
        rx2index++;
      }
    }
  }
  timerempfangRS232->start(100);
  if(leerdurchlauf == 20){
    timerempfangRS232->stop();
    fehleranzeige(1);
    clickifabbruch();
    return;
  }
}

void starcat::parametersetzen(){
  //Grundinitialisierung
  for(int i=0; i<100; i++){
    if(i<10){
      dspparam[i]->hide();
      ldspparam[i]->hide();
    }
    if(i%10 == 0){
      dspparam[i]->hide();
      ldspparam[i]->hide();
    }
    dspparam[i]->setRange(0.0,255.0);
    dspparam[i]->setValue(255.0);
    dspparam[i]->setDecimals(0);
  }
  for(int i=10;i<100;i++){
    dspparam[i]->hide();
    ldspparam[i]->hide();
    lparambeschr[i]->hide();
    if(rbssb->isChecked()){
      if(rbgn->isChecked()){
        setsparam(pssbgn[i],i);
      }
      if(rbge->isChecked()){
        if(pssbge[i] == 254){
          setsparam(pssbgn[i],i);
        }else{
          setsparam(pssbge[i],i);
        }
      }
      if(rbrt->isChecked()){
        if(pssbrt[i] == 254){
          setsparam(pssbgn[i],i);
        }else{
          setsparam(pssbrt[i],i);
        }
      }
    }
    if(rbcw->isChecked()){
      if(rbgn->isChecked()){
        setsparam(pcwgn[i],i);
      }
      if(rbge->isChecked()){
        if(pcwge[i] == 254){
          setsparam(pcwgn[i],i);
        }else{
          setsparam(pcwge[i],i);
        }
      }
      if(rbrt->isChecked()){
        if(pcwrt[i] == 254){
          setsparam(pcwgn[i],i);
        }else{
          setsparam(pcwrt[i],i);
        }
      }
    }
  }
  grafiksetzen();
}

void starcat::dspbufferloeschen(){
  //gdspg3xjp->setEnabled(FALSE);
  //gdspdl4jal->setEnabled(FALSE);
  buffer.clear();
  buf.clear();
  //textinfo->clear();
}

void starcat::parameterloeschen(){
  for(int i=0;i<100;i++){
    puserid[i] = 0;
    pssbgn[i] = 255;
    pssbge[i] = 255;
    pssbrt[i] = 255;
    pcwgn[i] = 255;
    pcwge[i] = 255;
    pcwrt[i] = 255;
    pmin[i] = 255;
    pmax[i] = 255;
    ppage[i] = 255;
    pfaktor[i] = 1.0;
    pbez[i] = "";
    pxparam[i] = FALSE;
  }
  for(int i=10;i<100;i++){
    if(i%10 == 0){
      dspparam[i]->hide();
    }else{
      dspparam[i]->show();
    }
    dspparam[i]->setRange(0.0,255.0);
    dspparam[i]->setValue(255.0);
    dspparam[i]->setDecimals(0);
    dspparam[i]->setEnabled(TRUE);
    ldspparam[i]->setText("");
  }
  dsptabwidget->setEnabled(FALSE);
  buttonparamsave->setEnabled(FALSE);
  buttonxparamsave->setEnabled(FALSE);
  cbdmoni->setEnabled(FALSE);
  grafiksetzen();
}

void starcat::initstepinfo(){
  QString qs = tr(
  "<b>Dieser Programmteil dient der Kalibrierung<br>"
  "der Verstaerkung vom AD603 (im STAR ZF-Platine)</b><br>"
  "<b>es entsteht eine Datei mit  64 DAC Werten.</b><br>"
  "<br>"
  "Benutzt wird das 20m-Band fuer die Messungen.<br>"
  "Weiterhin brauchen wir einen Signalgenaerator mit regelbarer Amplitude.<br>"
  );
  stepinfo->clear();
  stepinfo->append(qs);
  ifstep = 0;
}

void starcat::initstepsminfo(){
  QString qs = tr(
  "<b>Dieser Programmteil dient der Kalibrierung des S-Meters</b><br>"
  "Pro Band sind zwei Kalibriermoeglichkeiten \"best Noisfloor\" und \"best IP3\"<br>"
  "Die Daten sind Inhalt der \"scal.dat\" Kalibrierdatei.<br>"
  "Zusaetlich befinden sich in der Datei 4 mal dB-Abweichungen <br>"
  "der DDS-Einstellungen \"72\" \"43\" \"23\" \"79\".<br>"
  "Zum Kalibrieren benoetigen wir einen Signalgenaerator mit<br>"
  "regelbarer Amplitude und Frequenz.<br>"
  );
  stepsminfo->clear();
  stepsminfo->append(qs);
  smstep = 0;
}

void starcat::clickifabbruch(){
  initstepinfo();
  dsptabwidget->setEnabled(FALSE);
  parameterloeschen();
  for(int i=0; i<100; i++){
    dspparam[i]->setRange(0.0,255.0);
    dspparam[i]->setValue(255.0);
    dspparam[i]->setDecimals(0);
    dspparam[i]->setEnabled(TRUE);
  }
  buttonifstep->setText(tr("START"));
  dsptabwidget->setEnabled(FALSE);
}

void starcat::clicksmabbruch(){
  initstepsminfo();
  grsm->setEnabled(FALSE);
  parameterloeschen();
  for(int i=0; i<100; i++){
    dspparam[i]->setRange(0.0,255.0);
    dspparam[i]->setValue(255.0);
    dspparam[i]->setDecimals(0);
    dspparam[i]->setEnabled(TRUE);
  }
  buttonsmstep->setText(tr("START"));
  dsptabwidget->setEnabled(FALSE);
}

void starcat::paramSetEnabled(bool e){
  dsptabwidget->setEnabled(e);
  gparam->setEnabled(e);
  gseitenband->setEnabled(e);
  gmode->setEnabled(e);
  gbefehlsid->setEnabled(e);
  b1->setEnabled(e);
  b2->setEnabled(e);
  b3->setEnabled(e);
  b4->setEnabled(e);
  b5->setEnabled(e);
  b6->setEnabled(e);
  b7->setEnabled(e);
  b9->setEnabled(e);
  cbdmoni->setEnabled(e);
  //buttonparamsave->setEnabled(e);
}

void starcat::clickparamsave(){
  QFile f;
  QString k1="Parameter name         User#    Star# SSBGREEN SSBYELLOW SSBRED CWGREEN CWYELLOW CWRED  MIN     MAX         x   Page";
  QString k2="--------------         -----    ----- -------- --------- ------ ------- -------- -----  ---     ---         -   ----";
  QString qs;
  
  //qDebug("starcat::clickparamsave()");
  qs = QFileDialog::getSaveFileName(
        this
        ,tr("USER-Parameter Speichern","FileDialog")
        ,einst.parameterfilename[starnr]
        ,tr("Parameter (*.xjp *.XJP);;""Alle Dateien (*.*)","FileDialog")
        );
  if(! qs.isEmpty()){
    f.setFileName(qs);
    if(f.open(QIODevice::WriteOnly)){
      QTextStream ds(&f);
      ds << k1 << "\r\n";
      ds << k2 << "\r\n";
      for(int i=1; i<100; i++){
        if((pbez[i] != "") and (!pxparam[i])){
          qs.sprintf("%-23s, %2i ,\t %2i ,\t %3i ,\t %3i ,\t %3i ,\t %3i ,\t% 3i ,\t% 3i ,\t% 3i ,\t% 3i ,",
                    qPrintable(pbez[i]),
                    puserid[i],
                    i,
                    pssbgn[i],
                    pssbge[i],
                    pssbrt[i],
                    pcwgn[i],
                    pcwge[i],
                    pcwrt[i],
                    pmin[i],
                    pmax[i]);
          ds << qs;
          if((pfaktor[i] < 1.0) and (pfaktor[i] != 0.0)){
            qs.sprintf("\t %0.2f ,\t %2i", pfaktor[i], ppage[i]);
          }else{
            qs.sprintf("\t %4.0f ,\t %2i", pfaktor[i], ppage[i]);
          }
          ds << qs << "\r\n";
        }
      }
      ds << "END FILE" << "\r\n";
      bparamgeaendert = FALSE;
      buttonparamsave->setEnabled(FALSE);
    }
    f.close();
  }
}

void starcat::clickxparamsave(){
  QFile f;
  QString k1="Parameter name         User#    Star# SSBGREEN SSBYELLOW SSBRED CWGREEN CWYELLOW CWRED  MIN     MAX         x   Page";
  QString k2="--------------         -----    ----- -------- --------- ------ ------- -------- -----  ---     ---         -   ----";
  QString qs;
  
  //qDebug("starcat::clickxparamsave()");
  qs = QFileDialog::getSaveFileName(
        this
        ,tr("X-Parameter Speichern","FileDialog")
        ,einst.xparameterfilename[starnr]
        ,tr("X-Parameter (*.xjp *.XJP);;""Alle Dateien (*.*)","FileDialog")
        );
  if(!qs.isEmpty()){
    f.setFileName(qs);
    if(f.open(QIODevice::WriteOnly)){
      QTextStream ds(&f);
      ds << k1 << "\r\n";
      ds << k2 << "\r\n";
      for(int i=1; i<100; i++){
        if(pxparam[i]){
          qs.sprintf("%-24s, %2i ,\t %2i ,\t %3i ,\t %3i ,\t %3i ,\t %3i ,\t% 3i ,\t% 3i ,\t% 3i ,\t% 3i ,",
                    qPrintable(pbez[i]),
                    puserid[i],
                    i,
                    pssbgn[i],
                    pssbge[i],
                    pssbrt[i],
                    pcwgn[i],
                    pcwge[i],
                    pcwrt[i],
                    pmin[i],
                    pmax[i]);
          ds << qs;
          if((pfaktor[i] < 1.0) and (pfaktor[i] != 0.0)){
            qs.sprintf("\t %0.2f ,\t %2i", pfaktor[i], ppage[i]);
          }else{
            qs.sprintf("\t %4.0f ,\t %2i", pfaktor[i], ppage[i]);
          }
          ds << qs << "\r\n";
        }
      }
      ds << "END FILE" << "\r\n";
    }
    f.close();
    QString fn = einst.xparameterfilename[starnr];
    fn.replace(".xjp", ".dat");
    f.setFileName(fn);
    if(f.open(QIODevice::WriteOnly)){
      QTextStream ds(&f);
      
      int xlen = 64;
      int xsofar = 0;
      for(int i=11; i<100; i++)if(pxparam[i])xsofar++;
      for(int i=0; i<(xlen-xsofar); i++){
        ds << "000000" << "\r\n";
      }
      for(int i=99; i>=0; i--){
        if(pxparam[i]){
          qs.sprintf("%02X%02X%02X", i, pssbgn[i], pcwgn[i]);
          ds << qs << "\r\n";
        }
      }
      bxparamgeaendert = FALSE;
      buttonxparamsave->setEnabled(FALSE);
    }
    f.close(); 
  }
}

void starcat::actrepainttimer(){
  grafiksetzen();
  resize(this->rect().size());
  repainttimer->stop();
  //qDebug("kschreiber::actrepainttimer()");
}

void starcat::auswahlstar1(){
  star1Act->setChecked(TRUE);
  star2Act->setChecked(FALSE);
  star3Act->setChecked(FALSE);
  if(starnr != 0){
    dspbufferloeschen();
    parameterloeschen();
  }
  starnr = 0;
  setTextWindow();
  setHWText();
}

void starcat::auswahlstar2(){
  star2Act->setChecked(TRUE);
  star1Act->setChecked(FALSE);
  star3Act->setChecked(FALSE);
  if(starnr != 1){
    dspbufferloeschen();
    parameterloeschen();
  }
  starnr = 1;
  setTextWindow();
  setHWText();
}

void starcat::auswahlstar3(){
  star3Act->setChecked(TRUE);
  star2Act->setChecked(FALSE);
  star1Act->setChecked(FALSE);
  if(starnr != 2){
    dspbufferloeschen();
    parameterloeschen();
  }
  starnr = 2;
  setTextWindow();
  setHWText();
}

void starcat::fehleranzeige(int e){
  QString qs;
  QString f1 = tr(
  "<b>Datenempfang auf der RS232 defekt</B><BR>"
  "Es kommen vom PicAStar keine Daten zur Auswertung zum PC.<br> "
  "Eventuell ist die RS232 nicht angeschlossen oder<br> "
  "unterbrochen.");
  QString f3 = tr(
  "<b>Fehler im Datentelegramm vom PicAStar</B><BR>"
  "Es wird ein Zeichen als Echo erwartet, welches aber<br> "
  "nicht kommt.");

  switch(e){
    case 1:qs = f1; break;
    case 2:qs = "Fehler 2"; break;
    case 3:qs = f3; break;
    case 4:qs = f3; break;
    default:qs = "Fehler default";break;
  }
  QMessageBox::critical(this, tr("Fehler bei der ZF-Kalibrierung!"),qs);
}

void starcat::geaendertsm(){
  if(sm_geladen)timersmbef->start(200);
}

void starcat::tstopsmbef(){
  int wertalt;
  int wertneu;
  
  for(int i=0; i<11; i++){
    wertalt = dslnf[i];
    wertneu = slnf[i]->value();
    if(wertneu != wertalt){
      DSPcommando(67, wertneu);
      dslnf[i] = wertneu;
      return;
    }
  }
  for(int i=0; i<11; i++){
    wertalt = dslip3[i];
    wertneu = slip3[i]->value();
    if(wertneu != wertalt){
      DSPcommando(67, wertneu);
      dslip3[i] = wertneu;
      return;
    }
  }
  for(int i=0; i<4; i++){
    wertalt = dsldds[i];
    wertneu = sldds[i]->value();
    if(wertneu != wertalt){
      DSPcommando(67, wertneu + 0x80);
      dsldds[i] = wertneu;
      return;
    }
  }
  timersmbef->stop();
}

void starcat::delay(int zeit)
{
  if(zeit == 0)return;
  tstop = FALSE;
  testtimer->start(zeit);
  while(!tstop){
    qApp->processEvents();//Austritt aus der Funktion fuer Events
  }
}

void starcat::testtimerstop()
{
  tstop = TRUE;
  testtimer->stop();
}

void starcat::clickeesichern()
{
  uchar c;
  QFile f;
  int id;
  int re;
  QString qs;
  QString besch = tr(
  "<b>Der Inhalt des externen Eeproms PicAStar(DL4JAL) wird gesichert</b><br>"
  "Die Daten werden in die Datei \"exee.bin\" geschrieben.<br>"
  "<br>"
  "<b>Diese Funktion kann nur fuer den <b>PicAStar nach DL4JAL</b> verwendet werden !!!</b><br>"
  "<br>"
  "1. Verbindung <b>\"RS232-PIC\"</b> und <b>\"RS232-PC\"</b> herstellen.<br>"
  "2. Zuerst am PC in diesem Dialog <b>\"OK\"</b> druecken.<br>"
  "3. Anschliessend am \"PicAStar\" Funktion mit <b>\"997\"</b> starten<br>"
  "4. Der PicAStar beleibt auf Empfang bis die Funktion beendet ist<br>")
  ;

  //Der RS232 RX Buffer muss geleert werden
  while(defaultlesenrtty());
  if(QMessageBox::Ok == QMessageBox::information(this,
                                                 tr("Externen Eeprom SICHERN"),
                                                 besch, QMessageBox::Ok | QMessageBox::Cancel))
  {
     qs = QFileDialog::getSaveFileName(
            this
            ,tr("ExEeprominhalt Speichern","FileDialog")
            ,"*.bin"
            ,tr("Binaerdatei (*.bin *.BIN);;""Alle Dateien (*.*)","FileDialog")
            );
     if(! qs.isEmpty()){

       QProgressDialog prd(tr("ExEeprom in Datei Speichern"), tr("Abbrechen"), 0, 0xffff, this);
       prd.show();
       f.setFileName(qs);
       if(f.open(QIODevice::WriteOnly)){
         id = 0;
         QDataStream ds(&f);
         do{
           re = picmodem->readttybuffer(&c,1);
           qApp->processEvents();//Austritt aus der Funktion fuer Events
           if(prd.wasCanceled())return;
           prd.setValue(id);
           if(re == 1){
             id++; // Index um ein Zeichen weiter
             //Zeichen Eedatei schreiben
             ds << c;
           }
         }while(id <= 0xffff);
         prd.setValue(0xffff);
         //Kontrolldateien schliessen
         f.close();
      }
    }
  }
}

void starcat::clickeerestore()
{
  uchar c, c1;
  QFile f;
  int id;
  int re;
  QString qs;
  bool abbruch = FALSE;


  QString besch =tr(
      "<b>Der Inhalt des externen Eeproms PicAStar(DL4JAL) wird restauriert</b><br>"
      "Die Daten werden von der Datei \"*.bin\" geladen und in den externen<br>"
      "Eeprom des PicAStar zurueckgespeichert.<br>"
      "<br>"
      "<b>Diese Funktion kann nur fuer den <b>PicAStar nach DL4JAL</b> verwendet werden !!!</b><br>"
      "<br>"
      "1. Verbindung <b>\"RS232-PIC\"</b> und <b>\"RS232-PC\"</b> herstellen.<br>"
      "2. Am \"PicAStar\" Funktion mit <b>\"996\"</b> starten<br>"
      "3. Am PC in diesem Dialog <b>\"OK\"</b> druecken.<br>"
      "4. Anschliessend die Binaerdatei Laden.<br>"
      "5. Der PicAStar beleibt auf Empfang bis die Funktion beendet ist<br>")
      ;

  if(QMessageBox::Ok == QMessageBox::information(this,
                                                 tr("Externen Eeprom SICHERN"),
                                                 besch, QMessageBox::Ok | QMessageBox::Cancel))
  {
    qs = QFileDialog::getOpenFileName(
        this
        ,tr("ExEeprominhalt restaurieren","FileDialog")
        ,"*.bin"
        ,tr("Binaerdatei (*.bin *.BIN);;""Alle Dateien (*.*)","FileDialog")
        );
    if(! qs.isEmpty()){
      f.setFileName(qs);
      if(f.open(QIODevice::ReadOnly)){
        id = 0;
        QDataStream ds(&f);
        buffer.clear();
        while (!f.atEnd()){
          ds >> c;
          buffer.append(c);
        }
        f.close();
      }
    }
    QProgressDialog prd(tr("Daten in externen Eeprom Laden"), tr("Abbrechen"), 0, buffer.count(), this);
    prd.show();
    if(rs232isopen){
      while(defaultlesenrtty());//Der RS232 RX Buffer muss geleert werden
      int j=0;
      while(j<7){
        picchar2rs232('#');
        re = 0; //RS232 RX gelesen Zeichen = 0
        while(re != 1){ // Zeichen lesen
          re = picmodem->readttybuffer(&c,1);
          qApp->processEvents();//Austritt aus der Funktion fuer Events
          if(prd.wasCanceled ())return;
        };
        if(c == '#'){
          j++;
        }else{
          j=0;
        }
      }
      picchar2rs232('x');
      re = 0; //RS232 RX gelesen Zeichen = 0
      while(re != 1){ // Zeichen lesen
        re = picmodem->readttybuffer(&c,1);
        qApp->processEvents();//Austritt aus der Funktion fuer Events
        if(prd.wasCanceled ())return;
      };
      if(c != 'x'){
        QString qs;
        qs.sprintf("Keine Syncronisation!!!<br>\"x\" an PIC gesendet<br>\"%c\" vom PIC empfangen.",c);
        qs.sprintf("%c",c);
        qs = tr("Keine Syncronisation!!!<br>\"x\" an PIC gesendet<br>\"") + qs + tr("\" vom PIC empfangen.");
        QMessageBox::about(this, tr("Error!"),qs);
        return;
      }
      id = 0;
      do{
        prd.setValue(id);
        if(prd.wasCanceled())return;
        c1 = buffer.at(id); // Byte aus Buffer holen
        picchar2rs232(c1); //und in die RS232 TX geben
        id++; // Index um ein Zeichen weiter
        if(id == buffer.count())abbruch=TRUE; //Bufferende erreicht ABBRUCH
        re = 0; //RS232 RX gelesen Zeichen = 0
        while(re != 1){ // Zeichen lesen
          re = picmodem->readttybuffer(&c,1);
          qApp->processEvents();//Austritt aus der Funktion fuer Events
          if(prd.wasCanceled ())return;
        };
        if(c1 != c){
          QString qs,qs1,qs2;
          //qs.sprintf("Adresse %04x File:%x Pic:%x",id-1,c1,c);
          qs.sprintf("%04x",id-1);
          qs1.sprintf("%x",c1);
          qs2.sprintf("%x",c);
          qs = tr("Adresse ") + qs + tr(" File:") + qs1 + tr(" Pic:") + qs2;
          QMessageBox::about(this, tr("Error!"),qs);
          return;
        }
      }while(!abbruch);
      prd.setValue(buffer.count());
    }
  }
}

void starcat::rxslideraendern()
{
  lrxstatus->setText(tr("Einzelwert gesendet!"));
  timerrxeq->start(500);
}

void starcat::timerrxeqstop()
{
  QString qs, k1, k2;
  int eqpoint;
  int eqwert;
  uchar bhigh;
  uchar blow;
  bool ok;
  
  //qDebug("starcat::rxslideraendern()");
  timerrxeq->stop();
  for(int i=0; i<31; i++){
    if(rxvalue[i] != slrx[i]->value()){
      //qDebug("Slider %i Wert %i", i, slrx[i]->value());
      rxvalue[i] = slrx[i]->value();
      rxvaluealt[i] = slrx[i]->value();
      DSPcommando(114,i);
      eqpoint = slrx[i]->value();
      eqwert = sl2star(eqpoint);
      qs.sprintf("%X",eqwert);
      k1 = qs.left(2);
      k2 = qs.mid(2,2);
      bhigh = k1.toInt(&ok,16);
      blow = k2.toInt(&ok,16);
      DSPcommando(110,bhigh);
      DSPcommando(112,blow);
      DSPcommando(113,0);
      if(rxeqdateigeladen)buttonrxeqspeichern->setEnabled(TRUE);
    }
  }
  lrxstatus->setText("");
}

void starcat::txslideraendern()
{
  ltxstatus->setText(tr("Einzelwert gesendet!"));
  timertxeq->start(500);
}

void starcat::timertxeqstop()
{
  QString qs, k1, k2;
  int eqpoint;
  int eqwert;
  uchar bhigh;
  uchar blow;
  bool ok;
  
  //qDebug("starcat::txslideraendern()");
  timertxeq->stop();
  for(int i=0; i<31; i++){
    if(txvalue[i] != sltx[i]->value()){
      //qDebug("Slider %i Wert %i", i, sltx[i]->value());
      txvalue[i] = sltx[i]->value();
      txvaluealt[i] = sltx[i]->value();
      DSPcommando(114,i);
      eqpoint = sltx[i]->value();
      eqwert = sl2star(eqpoint);
      qs.sprintf("%X",eqwert);
      k1 = qs.left(2);
      k2 = qs.mid(2,2);
      bhigh = k1.toInt(&ok,16);
      blow = k2.toInt(&ok,16);
      DSPcommando(110,bhigh);
      DSPcommando(112,blow);
      DSPcommando(113,1);
      if(txeqdateigeladen)buttontxeqspeichern->setEnabled(TRUE);
    }
  }
  ltxstatus->setText("");
}

void starcat::picchar2rs232(uchar c)
{
   picmodem->writeChar(c);
   if(einst.picrs232writetime != 0)delay(einst.picrs232writetime);
}

void starcat::dspchar2rs232(uchar c)
{
   picmodem->writeChar(c);
   if(einst.dsprs232writetime != 0)delay(einst.dsprs232writetime);
}

void starcat::paramchar2rs232(uchar c)
{
   picmodem->writeChar(c);
   if(einst.paramrs232writetime != 0)delay(einst.paramrs232writetime);
}

void starcat::clickparam2pc()
{
  uchar c;
  QFile f;
  int id;
  int re;
  QString qs;
  unsigned char abuffer[0x400];

  for(int i=0;i<0x400;i++)abuffer[i]=255;
  QString besch =tr(
  "<b>Alle Parameter werden vom PicAStar(DL4JAL) zum </b><br>"
  "<b>PC geladen und kann anschliessend in einer Datei </b><br>"
  "<b>im XJP-Format abgespeichernt werden.</b><br>"
  "<br>"
  "1. Verbindung <b>\"RS232-PIC\"</b> und \"RS232-PC\" herstellen.<br>"
  "2. Die Firmware muss laufen. Also normaler Betrieb.<br>"
  "2. Zuerst am PC in diesem Dialog <b>\"OK\"</b> druecken.<br>"
  "3. Anschliessend am \"PicAStar\" Funktion mit <b>\"995\"</b> starten<br>"
  "4. Der PicAStar beleibt auf Empfang bis die Funktion <br>"
  "   beendet ist<br>"
  "5. Ist alles eingelesen wird sofort in das Parameter-Window <br>"
  "   gewechselt und das \"Speichern\" der Datei freigegeben.<br>"
  "<br>")
  ;
  if(QMessageBox::Ok == QMessageBox::information(this,
                                                 tr("Lesen der Paramter vom PicAstar (DL4JAL)"),
                                                 besch, QMessageBox::Ok | QMessageBox::Cancel)){

    QProgressDialog prd(tr("Parameter in Datei Speichern"), tr("Abbrechen"), 0, 0x3ff, this);
    prd.show();
    id = 0;
    textinfo->append(tr("Parameter vom Star lesen"));
    textinfo->append("---------------------------------");
    //Der RS232 RX Buffer muss geleert werden
    while(defaultlesenrtty());
    do{
      re = picmodem->readttybuffer(&c,1);
      qApp->processEvents();//Austritt aus der Funktion fuer Events
      if(prd.wasCanceled())return;
      prd.setValue(id);
      if(re == 1){
        abuffer[id] = c;
        id++; // Index um ein Zeichen weiter
      }
    }while(id != 0x3ff);
    //prd.setValue(0x3ff);
    textinfo->append(tr("Fertig"));
    textinfo->append("---------------------------------");
  }else{
    return;
  }
  bsmparam = FALSE;
  bxparam = FALSE;
  readparameter(einst.parameterfilename[starnr]);
  if(!bdateifehler){
    for(int i=10, id=0; i<100; i++, id++){
      pssbgn[i]= abuffer[id];
    }
    for(int i=10, id=90*1; i<100; i++, id++){
      pssbge[i]= abuffer[id];
    }
    for(int i=10, id=90*2; i<100; i++, id++){
      pssbrt[i]= abuffer[id];
    }
    for(int i=10, id=90*3; i<100; i++, id++){
      pmax[i]= abuffer[id];
    }
    for(int i=10, id=90*4; i<100; i++, id++){
      pmin[i]= abuffer[id];
    }
    for(int i=10, id=90*5; i<100; i++, id++){
      pcwgn[i]= abuffer[id];
    }
    for(int i=10, id=90*6; i<100; i++, id++){
      pcwge[i]= abuffer[id];
    }
    for(int i=10, id=90*7; i<100; i++, id++){
      pcwrt[i]= abuffer[id];
    }
    for(int i=10, id=90*8; i<100; i++, id++){
      puserid[i]= abuffer[id] + (i/10 * 10);
    }
    param_geladen = TRUE;
    parametersetzen();
    bparamgeaendert = FALSE;
    buttonparamsave->setEnabled(TRUE);
    awidget->setCurrentIndex(1);
  }
}

/*
void starcat::btest(){
  dmoni->show();
  loadcalcurve();
  while(defaultlesenrtty()); //RS232 Buffer leeren
  rxindex = 0;
  leerdurchlauf=0;
  timerdspmoni->start(100);
}
*/

void starcat::timerdspmonistop(){
  uchar abuffer[256];
  int a=0;
  int rx2index;
  QString qs;

  if (rs232isopen){
    a = picmodem->readttybuffer(abuffer, 256);
  }
  leerdurchlauf++;
  //qDebug("a= %i",a);
  for(int i=0; i<a; i++){
    leerdurchlauf = 0;
    rxbuffer[rxindex]=abuffer[i];
    rxindex++;
    if(rxindex==256)rxindex=0;
  }
  if(rxindex >= 26){
    rx2index = rxindex - 26;
    while(rx2index < rxindex){
      if(rxbuffer[rx2index] == '~'){
        rx2index++;
        if(rxbuffer[rx2index] == '~'){
          //qDebug("gefunden");
          dspdaten.adc = rxbuffer[rx2index+1] * 256 + rxbuffer[rx2index+2];
          hangstuff = rxbuffer[rx2index+3];
          if(hangstuff > 127){
            hangstuff -= 128;
            dspdaten.TXon = false;
          }else{
            dspdaten.TXon = true;
          }
          if(hangstuff > 63){
            hangstuff -= 64;
            dspdaten.hang = true;
          }else{
            HANG = 0;
            dspdaten.hang = false;
          }
          dspdaten.hff = 63 - hangstuff;
          dspdaten.dac = rxbuffer[rx2index+4] * 256 + rxbuffer[rx2index+5];
          dspdaten.devbyte1 = rxbuffer[rx2index+6] * 256 + rxbuffer[rx2index+7];
          dspdaten.devbyte2 = rxbuffer[rx2index+8] * 256 + rxbuffer[rx2index+9];
          dspdaten.devbyte3 = rxbuffer[rx2index+10] * 256 + rxbuffer[rx2index+11];
          dspdaten.devbyte4 = rxbuffer[rx2index+12] * 256 + rxbuffer[rx2index+13];
          dspdaten.devbyte5 = rxbuffer[rx2index+14] * 256 + rxbuffer[rx2index+15];
          dspdaten.devbyte6 = rxbuffer[rx2index+16] * 256 + rxbuffer[rx2index+17];
          dspdaten.sigdb = rxbuffer[rx2index+18];
          if(rxbuffer[rx2index+19] == 1){
            dspdaten.spk = true;
          }else{
            dspdaten.spk = false;
          }
          dspdaten.preADCgain = uchar(rxbuffer[rx2index+20]/16);
          dspdaten.adcdb = qRound(dspdaten.preADCgain * 1.5);
          dspdaten.sled = (rxbuffer[rx2index+20] - (dspdaten.preADCgain * 16)) * 256;
          dspdaten.sled += rxbuffer[rx2index+21];
          int sled = 0;
          if(dspdaten.sled == 1)sled = 1;
          if(dspdaten.sled == 3)sled = 2;
          if(dspdaten.sled == 7)sled = 3;
          if(dspdaten.sled == 15)sled = 4;
          if(dspdaten.sled == 31)sled = 5;
          if(dspdaten.sled == 63)sled = 6;
          if(dspdaten.sled == 127)sled = 7;
          if(dspdaten.sled == 255)sled = 8;
          if(dspdaten.sled == 511)sled = 9;
          if(dspdaten.sled == 1023)sled = 10;
          if(dspdaten.sled == 2047)sled = 11;
          if(dspdaten.sled == 4095)sled = 12;
          dspdaten.sled = sled;
          //qDebug()<<hangstuff;
          dspdaten.gn = rxbuffer[rx2index+22];
          if(dspdaten.TXon){
            dspdaten.agcdb = dspdaten.gn - 28;
            if(dspdaten.agcdb < 0)dspdaten.agcdb = 0;
            if(dspdaten.agcdb > 72)dspdaten.agcdb = 72;
          }else{
            dspdaten.micegain = dspdaten.gn - 100 + 36;
          }
          dspdaten.gain = 0;
          for(int i=0; i<43; i++){
            if(calcurve[i+1] >= hangstuff){
              dspdaten.gain = i;
              break;
            }
          }
          rxindex = 0;

          emit sendedspdaten(dspdaten);
        }
      }else{
        rx2index++;
      }
    }
  }
  timerdspmoni->start(100);
}

void starcat::loadcalcurve(){
  QFile f;
  int zeilennr;
  QString qs;
  int wert;
  bool ok;

  f.setFileName(einst.ad603filename[starnr]);
  if(f.open(QIODevice::ReadOnly)){
    QTextStream ts(&f);
    zeilennr = 0;
    while(!ts.atEnd()){
      qs = ts.readLine();
      //qDebug()<<qs;
      qs = qs.mid(2,2);
      //qDebug()<<qs;
      wert = qs.toInt(&ok,16);
      //qDebug()<<wert;
      calcurve[zeilennr] = double(wert);
      //qDebug()<<calcurve[zeilennr];
      zeilennr++;
    };
    f.close();
  }
}

void starcat::setdmoni(){
  if(cbdmoni->isChecked()){
    DSPcommando(52,2);
    dmoni->show();
    loadcalcurve();
    while(defaultlesenrtty()); //RS232 Buffer leeren
    rxindex = 0;
    leerdurchlauf=0;
    timerdspmoni->start(100);
  }else{
    dmoni->hide();
    while(defaultlesenrtty()); //RS232 Buffer leeren
    timerdspmoni->stop();
    DSPcommando(52,1);
  }
}
