/***************************************************************************
 *   Copyright (C) 2009 by Andreas Lindenau   *
 *   DL4JAL@darc.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef starcat_H
#define starcat_H

#include <QMainWindow>
#include <QCloseEvent>
#include <QLineEdit>
#include <QLabel>
#include <QCheckBox>
#include <QGroupBox>
#include <QRadioButton>
#include <QProgressDialog>
#include <QDoubleSpinBox>
#include <QPushButton>
#include <QTimer>
#include <QDir>
//#include <QTest>
#ifdef Q_WS_WIN
#include "win_modem.h"
#else
#include "lin_modem.h"
#endif

#include "konstdef.h"
#include "optiondlg.h"
#include "dspmonitor.h"

class QAction;
class QMenu;
class QTabWidget;
class QWidget;
class QTextEdit;
class QComboBox;
class QDoubleSpinBox;
class QSlider;
class QMessageBox;
class QCheckBox;


class starcat:public QMainWindow
{
      Q_OBJECT

public:
  starcat();
  ~starcat();

protected:
  void closeEvent(QCloseEvent *event);
  virtual void resizeEvent( QResizeEvent *);
  virtual void repaintEvent( QPaintEvent *);

private slots:
//  void btest();
  void about();
  void meinst();
  void meinstsave();
  void setAText(QString);
  void clickfileladen();
  void clickparamladen();
  void clicktestladen();
  void clickdspladen();
  void clickeesichern();
  void clickeerestore();
  void clickparam2pc();
  //void clickdspladen_dl4jal();
  //void clickpicladen();
  void clickpicladen();
  void clickdspbefehl();
  //void clickpar2pic();
  void clickpar2pic();
  void tstopdspbef();
  void dspbefehl();
  void setb1();
  void setb2();
  void setb3();
  void setb4();
  void setb5();
  void setb6();
  void setb7();
  void setb9();
  void setparamgruppegn();
  void setparamgruppege();
  void setparamgruppert();
  void setparamgruppessb();
  void setparamgruppecw();
  void clickrxeqladen();
  void clicktxeqladen();
  void clickrxeq2pic();
  void clicktxeq2pic();
  void clickrxeqspeichern();
  void clicktxeqspeichern();
  void clickifstep();
  void clickifabbruch();
  void clicksmstep();
  void clicksmabbruch();
  void tstopempfangRS232();
  void clickparamsave();
  void clickxparamladen();
  void clickxparamsave();
  void actrepainttimer();
  void setuserid();
  void setstarid();
  void auswahlstar1();
  void auswahlstar2();
  void auswahlstar3();
  void geaendertsm();
  void tstopsmbef();
  void setparamusb();
  void setparamlsb();
  void testtimerstop();
  void rxslideraendern();
  void timerrxeqstop();
  void txslideraendern();
  void timertxeqstop();
  void timerdspmonistop();
  void loadcalcurve();
  void setdmoni();

private:
  void setHWText();
  void createActions();
  void createMenus();
  void createToolBars();
  void createStatusBar();
  void readSettings();
  void writeSettings();
  bool defaultlesenrtty();
  void cfgladen();
  void cfgspeichern();
  void grafiksetzen();
  void dsplist2buffer();
  void filterlist2buffer();
  void DSPcommando(uchar nr, uchar value);
  void updatechecksumme();
  void loadchecksumme();
  void buffer2dsp();
  //void buffer2pic_neu();
  void buffer2pic_alt();
  void readparameter(const QString pfname);
  void readscalparam();
  void savescalparam();
  void parameter2dsp();
  //void parameter2pic_neu();
  void parameter2pic_alt();
  void setsparam(int, int);
  int star2sl(int);
  int sl2star(int);
  void delay(int);
  void picchar2rs232(uchar);
  void dspchar2rs232(uchar);
  void paramchar2rs232(uchar);

  void parameterloeschen();
  void parametersetzen();
  void initstepinfo();
  void initstepsminfo();
  void paramSetEnabled(bool);
  void fehleranzeige(int);
  void dspbufferloeschen();
  void setTextWindow();
  
  QString version, verdatum;
  QString zeile;
  QDir  homedir;
  
//  QTest twait;
  odlg *dlgeinst;
  TEinstellungen einst;
  int starnr;
  int checksum;
  uchar cka, ckb, ckc;
  //uchar befehl[100];
  //uchar value[100];
  uchar rxbuffer[256];
  double calcurve[64];
  int ccidx;
  int rxindex;
  unsigned int adc;
  unsigned char hangstuff;
  unsigned int dac;
  unsigned int devbyte1;
  unsigned int devbyte2;
  unsigned int devbyte3;
  unsigned int devbyte4;
  unsigned int devbyte5;
  unsigned int devbyte6;
  unsigned char sigdb;
  unsigned char spk;
  unsigned char uartADCgain;
  unsigned char sled;
  unsigned char gn;
  int TorR;
  int HANG;
  int ifstep;
  int smstep;
  bool bsmparam;
  bool bxparam;
  int dB;
  bool bstart;
  int messzyklen;
  int leerdurchlauf;
  bool bende;
  double messergebnis;
  double messung1;
  double messung2;
  int op[47];
  int paramid;
  int puserid[100];
  int pssbgn[100];
  int pssbge[100];
  int pssbrt[100];
  int pcwgn[100];
  int pcwge[100];
  int pcwrt[100];
  int pmin[100];
  int pmax[100];
  int ppage[100];
  bool pxparam[100];
  double pfaktor[100];
  QString pbez[100];
  QString paramkopf1;
  QString paramkopf2;
  int dslip3[11];
  int dslnf[11];
  int dsldds[4];
  int DSPbef;
  int DSPwert;
  bool sm_geladen;
  bool bparamgeaendert;
  bool bxparamgeaendert;
  bool tstop;
  int rxvalue[31];
  int rxvaluealt[31];
  bool rxeqdateigeladen;
  int txvalue[31];
  int txvaluealt[31];
  bool txeqdateigeladen;
  TDspDaten dspdaten;
  
  QTabWidget *awidget;
  QWidget *wstarcat; //DSP Laden
  
  QWidget *wrxeq; //TX Equalizer
  QGroupBox *grxeq;
  QSlider *slrx[31];
  QLabel *slrxlabel1[14];
  QLabel *slrxlabel2[14];
  QLabel *slrxlabel3[32];
  QLabel *slrxlabel4[32];
  QPushButton *buttonrxeqladen;
  QPushButton *buttonrxeqspeichern;
  QPushButton *buttonrxeq2pic;
  QLabel *lrxstatus;
  
  QWidget *wtxeq; //TX Equalizer
  QGroupBox *gtxeq;
  QSlider *sltx[31];
  QLabel *sltxlabel1[14];
  QLabel *sltxlabel2[14];
  QLabel *sltxlabel3[32];
  QLabel *sltxlabel4[32];
  QPushButton *buttontxeqladen;
  QPushButton *buttontxeqspeichern;
  QPushButton *buttontxeq2pic;
  QLabel *ltxstatus;
  
  QWidget *wifcal; //AD603 Kalibrierung
  QProgressBar *pbagc;
  QTextEdit *stepinfo;
  QPushButton *buttonifstep;
  QPushButton *buttonifabbruch;
  QLabel *lpbagc;
  
  QWidget *wsmcal; //S-Meter Kalibrierung
  QProgressBar *pbsmagc;
  QTextEdit *stepsminfo;
  QPushButton *buttonsmstep;
  QPushButton *buttonsmabbruch;
  QLabel *lpbsmagc;
  
  QGroupBox *grsm;
  QLabel *lsm[18];
  QStringList strsm;
  QSpinBox *slip3[11];
  QSpinBox *slnf[11];
  QSpinBox *sldds[4];
  
  QMenu *fileMenu;
  QMenu *optionMenu;
  QMenu *helpMenu;
  QMenu *starMenu;
  QToolBar *fileToolBar;
  QAction *exitAct;
  QAction *aboutAct;
  QAction *aboutQtAct;
  QAction *einstAct;
  QAction *star1Act;
  QAction *star2Act;
  QAction *star3Act;
  
  //QPushButton *buttontest;
  QPushButton *buttondspladen;
  QPushButton *buttoneesichern;
  QPushButton *buttondspbefehl;
  QPushButton *buttoneerestore;
  QPushButton *buttonparam2pc;

  QPushButton *buttonpicladen;
  QPushButton *buttonfileladen1;
  QPushButton *buttonxparamladen;
  QPushButton *buttonxparamsave;
  QPushButton *buttonparamsave;
  QPushButton *buttonpar2pic;
  QPushButton *buttontestladen;
  
  QGroupBox *gdspg3xjp;
  QGroupBox *gdspdl4jal;
  QGroupBox *gtestladen;
  QGroupBox *gdspbefehl;
  
  QCheckBox *b1;
  QCheckBox *b2;
  QCheckBox *b3;
  QCheckBox *b4;
  QCheckBox *b5;
  QCheckBox *b6;
  QCheckBox *b7;
  QCheckBox *b9;
  QCheckBox *cbdmoni;

  QGroupBox *gparam;
  QRadioButton *rbgn;
  QRadioButton *rbge;
  QRadioButton *rbrt;
  
  QGroupBox *gseitenband;
  QRadioButton *rbusb;
  QRadioButton *rblsb;
  
  QGroupBox *gmode;
  QRadioButton *rbssb;
  QRadioButton *rbcw;
  
  QGroupBox *gbefehlsid;
  QRadioButton *rbuser;
  QRadioButton *rbstar;
  
  QLineEdit *dspid;
  QLineEdit *dspwert;
  
  QTextEdit *textinfo;
  
  QStringList listdspcode;
  QStringList listfilter;
  QStringList listparameter;
  QList<uchar> buffer;
  QList<uchar> buf;
  
  QWidget *wdspparam;
  //QGroupBox *gdspparam;
  QTabWidget *dsptabwidget;
  QWidget *wdsp[3];
  QDoubleSpinBox *dspparam[100];
  QLabel *ldspparam[100];
  QLabel *lparambeschr[100];
  int param[100];
  int paramalt[100];
  DspMonitor *dmoni;
  
  Modem *picmodem;
  bool rs232isopen;
  bool param_geladen;
  bool bdateifehler;

  QTimer *testtimer;
  QTimer *repainttimer;
  QTimer *timerdspbef;
  QTimer *timersmbef;
  QTimer *timerempfangRS232;
  QTimer *timerrxeq;
  QTimer *timertxeq;
  QTimer *timerdspmoni;

signals:
  void sendedspdaten(const TDspDaten&);

};

#endif
